/* Upgrades.c generated by valac 0.12.0, the Vala compiler
 * generated from Upgrades.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* Class for aggregating one-off "upgrade" tasks that occur at startup, such as*/
/* moving or deleting files. This occurs after the UI is shown, so it's not appropriate*/
/* for database updates and such.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_UPGRADES (upgrades_get_type ())
#define UPGRADES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UPGRADES, Upgrades))
#define UPGRADES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UPGRADES, UpgradesClass))
#define IS_UPGRADES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UPGRADES))
#define IS_UPGRADES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UPGRADES))
#define UPGRADES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UPGRADES, UpgradesClass))

typedef struct _Upgrades Upgrades;
typedef struct _UpgradesClass UpgradesClass;
typedef struct _UpgradesPrivate UpgradesPrivate;

#define TYPE_UPGRADE_TASK (upgrade_task_get_type ())
#define UPGRADE_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UPGRADE_TASK, UpgradeTask))
#define IS_UPGRADE_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UPGRADE_TASK))
#define UPGRADE_TASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_UPGRADE_TASK, UpgradeTaskIface))

typedef struct _UpgradeTask UpgradeTask;
typedef struct _UpgradeTaskIface UpgradeTaskIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MIMICS_REMOVAL_TASK (mimics_removal_task_get_type ())
#define MIMICS_REMOVAL_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTask))
#define MIMICS_REMOVAL_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskClass))
#define IS_MIMICS_REMOVAL_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIMICS_REMOVAL_TASK))
#define IS_MIMICS_REMOVAL_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIMICS_REMOVAL_TASK))
#define MIMICS_REMOVAL_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskClass))

typedef struct _MimicsRemovalTask MimicsRemovalTask;
typedef struct _MimicsRemovalTaskClass MimicsRemovalTaskClass;
#define _upgrades_unref0(var) ((var == NULL) ? NULL : (var = (upgrades_unref (var), NULL)))
typedef struct _ParamSpecUpgrades ParamSpecUpgrades;
typedef struct _MimicsRemovalTaskPrivate MimicsRemovalTaskPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Upgrades {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UpgradesPrivate * priv;
};

struct _UpgradesClass {
	GTypeClass parent_class;
	void (*finalize) (Upgrades *self);
};

typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _UpgradeTaskIface {
	GTypeInterface parent_iface;
	guint64 (*get_step_count) (UpgradeTask* self);
	void (*execute) (UpgradeTask* self, ProgressMonitor monitor, void* monitor_target);
};

struct _UpgradesPrivate {
	guint64 total_steps;
	GeeLinkedList* task_list;
};

struct _ParamSpecUpgrades {
	GParamSpec parent_instance;
};

struct _MimicsRemovalTask {
	GObject parent_instance;
	MimicsRemovalTaskPrivate * priv;
};

struct _MimicsRemovalTaskClass {
	GObjectClass parent_class;
};

struct _MimicsRemovalTaskPrivate {
	GFile* mimic_dir;
	guint64 num_mimics;
};


static gpointer upgrades_parent_class = NULL;
static Upgrades* upgrades_instance;
static Upgrades* upgrades_instance = NULL;
static gpointer mimics_removal_task_parent_class = NULL;
static UpgradeTaskIface* mimics_removal_task_upgrade_task_parent_iface = NULL;

gpointer upgrades_ref (gpointer instance);
void upgrades_unref (gpointer instance);
GParamSpec* param_spec_upgrades (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_upgrades (GValue* value, gpointer v_object);
void value_take_upgrades (GValue* value, gpointer v_object);
gpointer value_get_upgrades (const GValue* value);
GType upgrades_get_type (void) G_GNUC_CONST;
GType upgrade_task_get_type (void) G_GNUC_CONST;
#define UPGRADES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UPGRADES, UpgradesPrivate))
enum  {
	UPGRADES_DUMMY_PROPERTY
};
static Upgrades* upgrades_new (void);
static Upgrades* upgrades_construct (GType object_type);
static void upgrades_add (Upgrades* self, UpgradeTask* task);
MimicsRemovalTask* mimics_removal_task_new (void);
MimicsRemovalTask* mimics_removal_task_construct (GType object_type);
GType mimics_removal_task_get_type (void) G_GNUC_CONST;
void upgrades_init (void);
Upgrades* upgrades_get_instance (void);
guint64 upgrades_get_step_count (Upgrades* self);
void upgrades_execute (Upgrades* self, ProgressMonitor monitor, void* monitor_target);
void upgrade_task_execute (UpgradeTask* self, ProgressMonitor monitor, void* monitor_target);
guint64 upgrade_task_get_step_count (UpgradeTask* self);
static void upgrades_finalize (Upgrades* obj);
#define MIMICS_REMOVAL_TASK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskPrivate))
enum  {
	MIMICS_REMOVAL_TASK_DUMMY_PROPERTY
};
GFile* app_dirs_get_data_dir (void);
static guint64 mimics_removal_task_real_get_step_count (UpgradeTask* base);
guint64 count_files_in_directory (GFile* dir, GError** error);
static void mimics_removal_task_real_execute (UpgradeTask* base, ProgressMonitor monitor, void* monitor_target);
void delete_all_files (GFile* dir, GeeSet* exceptions, ProgressMonitor monitor, void* monitor_target, guint64 file_count, GCancellable* cancellable, GError** error);
static void mimics_removal_task_finalize (GObject* obj);


static Upgrades* upgrades_construct (GType object_type) {
	Upgrades* self = NULL;
	MimicsRemovalTask* _tmp0_ = NULL;
	MimicsRemovalTask* _tmp1_;
	self = (Upgrades*) g_type_create_instance (object_type);
	_tmp0_ = mimics_removal_task_new ();
	_tmp1_ = _tmp0_;
	upgrades_add (self, UPGRADE_TASK (_tmp1_));
	_g_object_unref0 (_tmp1_);
	return self;
}


static Upgrades* upgrades_new (void) {
	return upgrades_construct (TYPE_UPGRADES);
}


void upgrades_init (void) {
	Upgrades* _tmp0_ = NULL;
	g_assert (upgrades_instance == NULL);
	_tmp0_ = upgrades_new ();
	_upgrades_unref0 (upgrades_instance);
	upgrades_instance = _tmp0_;
}


static gpointer _upgrades_ref0 (gpointer self) {
	return self ? upgrades_ref (self) : NULL;
}


Upgrades* upgrades_get_instance (void) {
	Upgrades* result = NULL;
	Upgrades* _tmp0_;
	_tmp0_ = _upgrades_ref0 (upgrades_instance);
	result = _tmp0_;
	return result;
}


guint64 upgrades_get_step_count (Upgrades* self) {
	guint64 result = 0ULL;
	g_return_val_if_fail (IS_UPGRADES (self), 0ULL);
	result = self->priv->total_steps;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void upgrades_execute (Upgrades* self, ProgressMonitor monitor, void* monitor_target) {
	g_return_if_fail (IS_UPGRADES (self));
	{
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _task_list;
		gint _tmp1_;
		gint _task_size;
		gint _task_index;
		_tmp0_ = _g_object_ref0 (self->priv->task_list);
		_task_list = _tmp0_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (_task_list));
		_task_size = _tmp1_;
		_task_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			UpgradeTask* task;
			_task_index = _task_index + 1;
			if (!(_task_index < _task_size)) {
				break;
			}
			_tmp2_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_task_list), _task_index);
			task = (UpgradeTask*) _tmp2_;
			upgrade_task_execute (task, monitor, monitor_target);
			_g_object_unref0 (task);
		}
		_g_object_unref0 (_task_list);
	}
}


static void upgrades_add (Upgrades* self, UpgradeTask* task) {
	guint64 _tmp0_;
	g_return_if_fail (IS_UPGRADES (self));
	g_return_if_fail (IS_UPGRADE_TASK (task));
	_tmp0_ = upgrade_task_get_step_count (task);
	self->priv->total_steps = self->priv->total_steps + _tmp0_;
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->task_list), task);
}


static void value_upgrades_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_upgrades_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		upgrades_unref (value->data[0].v_pointer);
	}
}


static void value_upgrades_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = upgrades_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_upgrades_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_upgrades_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Upgrades* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = upgrades_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_upgrades_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Upgrades** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = upgrades_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_upgrades (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUpgrades* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UPGRADES), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_upgrades (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES), NULL);
	return value->data[0].v_pointer;
}


void value_set_upgrades (GValue* value, gpointer v_object) {
	Upgrades* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UPGRADES));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		upgrades_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		upgrades_unref (old);
	}
}


void value_take_upgrades (GValue* value, gpointer v_object) {
	Upgrades* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UPGRADES));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		upgrades_unref (old);
	}
}


static void upgrades_class_init (UpgradesClass * klass) {
	upgrades_parent_class = g_type_class_peek_parent (klass);
	UPGRADES_CLASS (klass)->finalize = upgrades_finalize;
	g_type_class_add_private (klass, sizeof (UpgradesPrivate));
}


static void upgrades_instance_init (Upgrades * self) {
	GeeLinkedList* _tmp0_ = NULL;
	self->priv = UPGRADES_GET_PRIVATE (self);
	self->priv->total_steps = (guint64) 0;
	_tmp0_ = gee_linked_list_new (TYPE_UPGRADE_TASK, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->priv->task_list = _tmp0_;
	self->ref_count = 1;
}


static void upgrades_finalize (Upgrades* obj) {
	Upgrades * self;
	self = UPGRADES (obj);
	_g_object_unref0 (self->priv->task_list);
}


GType upgrades_get_type (void) {
	static volatile gsize upgrades_type_id__volatile = 0;
	if (g_once_init_enter (&upgrades_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_upgrades_init, value_upgrades_free_value, value_upgrades_copy_value, value_upgrades_peek_pointer, "p", value_upgrades_collect_value, "p", value_upgrades_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UpgradesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upgrades_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Upgrades), 0, (GInstanceInitFunc) upgrades_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType upgrades_type_id;
		upgrades_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Upgrades", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&upgrades_type_id__volatile, upgrades_type_id);
	}
	return upgrades_type_id__volatile;
}


gpointer upgrades_ref (gpointer instance) {
	Upgrades* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void upgrades_unref (gpointer instance) {
	Upgrades* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UPGRADES_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


guint64 upgrade_task_get_step_count (UpgradeTask* self) {
	return UPGRADE_TASK_GET_INTERFACE (self)->get_step_count (self);
}


void upgrade_task_execute (UpgradeTask* self, ProgressMonitor monitor, void* monitor_target) {
	UPGRADE_TASK_GET_INTERFACE (self)->execute (self, monitor, monitor_target);
}


static void upgrade_task_base_init (UpgradeTaskIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType upgrade_task_get_type (void) {
	static volatile gsize upgrade_task_type_id__volatile = 0;
	if (g_once_init_enter (&upgrade_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UpgradeTaskIface), (GBaseInitFunc) upgrade_task_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType upgrade_task_type_id;
		upgrade_task_type_id = g_type_register_static (G_TYPE_INTERFACE, "UpgradeTask", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (upgrade_task_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&upgrade_task_type_id__volatile, upgrade_task_type_id);
	}
	return upgrade_task_type_id__volatile;
}


static guint64 mimics_removal_task_real_get_step_count (UpgradeTask* base) {
	MimicsRemovalTask * self;
	guint64 result = 0ULL;
	guint64 _tmp0_;
	guint64 _tmp1_;
	GError * _inner_error_ = NULL;
	self = MIMICS_REMOVAL_TASK (base);
	_tmp0_ = count_files_in_directory (self->priv->mimic_dir, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		goto __catch552_g_error;
	}
	self->priv->num_mimics = _tmp1_;
	goto __finally552;
	__catch552_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_debug ("Upgrades.vala:72: Error on deleting mimics: %s", e->message);
		_g_error_free0 (e);
	}
	__finally552:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0ULL;
	}
	result = self->priv->num_mimics;
	return result;
}


static void mimics_removal_task_real_execute (UpgradeTask* base, ProgressMonitor monitor, void* monitor_target) {
	MimicsRemovalTask * self;
	GError * _inner_error_ = NULL;
	self = MIMICS_REMOVAL_TASK (base);
	delete_all_files (self->priv->mimic_dir, NULL, monitor, monitor_target, self->priv->num_mimics, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch553_g_error;
	}
	g_file_delete (self->priv->mimic_dir, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch553_g_error;
	}
	goto __finally553;
	__catch553_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_debug ("Upgrades.vala:82: Could not delete mimics: %s", e->message);
		_g_error_free0 (e);
	}
	__finally553:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


MimicsRemovalTask* mimics_removal_task_construct (GType object_type) {
	MimicsRemovalTask * self = NULL;
	self = (MimicsRemovalTask*) g_object_new (object_type, NULL);
	return self;
}


MimicsRemovalTask* mimics_removal_task_new (void) {
	return mimics_removal_task_construct (TYPE_MIMICS_REMOVAL_TASK);
}


static void mimics_removal_task_class_init (MimicsRemovalTaskClass * klass) {
	mimics_removal_task_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MimicsRemovalTaskPrivate));
	G_OBJECT_CLASS (klass)->finalize = mimics_removal_task_finalize;
}


static void mimics_removal_task_upgrade_task_interface_init (UpgradeTaskIface * iface) {
	mimics_removal_task_upgrade_task_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_step_count = (guint64 (*)(UpgradeTask*)) mimics_removal_task_real_get_step_count;
	iface->execute = (void (*)(UpgradeTask* ,ProgressMonitor ,void*)) mimics_removal_task_real_execute;
}


static void mimics_removal_task_instance_init (MimicsRemovalTask * self) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	self->priv = MIMICS_REMOVAL_TASK_GET_PRIVATE (self);
	_tmp0_ = app_dirs_get_data_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_child (_tmp1_, "mimics");
	self->priv->mimic_dir = _tmp2_;
	_g_object_unref0 (_tmp1_);
	self->priv->num_mimics = (guint64) 0;
}


static void mimics_removal_task_finalize (GObject* obj) {
	MimicsRemovalTask * self;
	self = MIMICS_REMOVAL_TASK (obj);
	_g_object_unref0 (self->priv->mimic_dir);
	G_OBJECT_CLASS (mimics_removal_task_parent_class)->finalize (obj);
}


GType mimics_removal_task_get_type (void) {
	static volatile gsize mimics_removal_task_type_id__volatile = 0;
	if (g_once_init_enter (&mimics_removal_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MimicsRemovalTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mimics_removal_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MimicsRemovalTask), 0, (GInstanceInitFunc) mimics_removal_task_instance_init, NULL };
		static const GInterfaceInfo upgrade_task_info = { (GInterfaceInitFunc) mimics_removal_task_upgrade_task_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType mimics_removal_task_type_id;
		mimics_removal_task_type_id = g_type_register_static (G_TYPE_OBJECT, "MimicsRemovalTask", &g_define_type_info, 0);
		g_type_add_interface_static (mimics_removal_task_type_id, TYPE_UPGRADE_TASK, &upgrade_task_info);
		g_once_init_leave (&mimics_removal_task_type_id__volatile, mimics_removal_task_type_id);
	}
	return mimics_removal_task_type_id__volatile;
}



