/* Config.c generated by valac 0.12.0, the Vala compiler
 * generated from Config.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* This file is the master unit file for the Config unit.  It should be edited to include
 * whatever code is deemed necessary.
 *
 * The init() and terminate() methods are mandatory.
 *
 * If the unit needs to be configured prior to initialization, add the proper parameters to
 * the preconfigure() method, implement it, and ensure in init() that it's been called.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;
typedef struct _ConfigurationFacadePrivate ConfigurationFacadePrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())

#define TYPE_FUZZY_PROPERTY_STATE (fuzzy_property_state_get_type ())

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef struct _ConfigFacadePrivate ConfigFacadePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_HYBRID_CONFIGURATION_ENGINE (hybrid_configuration_engine_get_type ())
#define HYBRID_CONFIGURATION_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HYBRID_CONFIGURATION_ENGINE, HybridConfigurationEngine))
#define HYBRID_CONFIGURATION_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HYBRID_CONFIGURATION_ENGINE, HybridConfigurationEngineClass))
#define IS_HYBRID_CONFIGURATION_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HYBRID_CONFIGURATION_ENGINE))
#define IS_HYBRID_CONFIGURATION_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HYBRID_CONFIGURATION_ENGINE))
#define HYBRID_CONFIGURATION_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HYBRID_CONFIGURATION_ENGINE, HybridConfigurationEngineClass))

typedef struct _HybridConfigurationEngine HybridConfigurationEngine;
typedef struct _HybridConfigurationEngineClass HybridConfigurationEngineClass;

#define TYPE_CONFIGURATION_ENGINE (configuration_engine_get_type ())
#define CONFIGURATION_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_ENGINE, ConfigurationEngine))
#define IS_CONFIGURATION_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_ENGINE))
#define CONFIGURATION_ENGINE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONFIGURATION_ENGINE, ConfigurationEngineIface))

typedef struct _ConfigurationEngine ConfigurationEngine;
typedef struct _ConfigurationEngineIface ConfigurationEngineIface;

#define TYPE_CONFIGURABLE_PROPERTY (configurable_property_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

typedef enum  {
	FUZZY_PROPERTY_STATE_ENABLED,
	FUZZY_PROPERTY_STATE_DISABLED,
	FUZZY_PROPERTY_STATE_UNKNOWN
} FuzzyPropertyState;

struct _ConfigurationFacade {
	GObject parent_instance;
	ConfigurationFacadePrivate * priv;
};

struct _ConfigurationFacadeClass {
	GObjectClass parent_class;
	gboolean (*get_auto_import_from_library) (ConfigurationFacade* self);
	void (*set_auto_import_from_library) (ConfigurationFacade* self, gboolean auto_import);
	gchar* (*get_bg_color_name) (ConfigurationFacade* self);
	void (*set_bg_color_name) (ConfigurationFacade* self, const gchar* color_name);
	gboolean (*get_commit_metadata_to_masters) (ConfigurationFacade* self);
	void (*set_commit_metadata_to_masters) (ConfigurationFacade* self, gboolean commit_metadata);
	gchar* (*get_desktop_background) (ConfigurationFacade* self);
	void (*set_desktop_background) (ConfigurationFacade* self, const gchar* filename);
	gchar* (*get_directory_pattern) (ConfigurationFacade* self);
	void (*set_directory_pattern) (ConfigurationFacade* self, const gchar* s);
	gchar* (*get_directory_pattern_custom) (ConfigurationFacade* self);
	void (*set_directory_pattern_custom) (ConfigurationFacade* self, const gchar* s);
	void (*get_direct_window_state) (ConfigurationFacade* self, gboolean* maximize, Dimensions* dimensions);
	void (*set_direct_window_state) (ConfigurationFacade* self, gboolean maximize, Dimensions* dimensions);
	gboolean (*get_display_basic_properties) (ConfigurationFacade* self);
	void (*set_display_basic_properties) (ConfigurationFacade* self, gboolean display);
	gboolean (*get_display_extended_properties) (ConfigurationFacade* self);
	void (*set_display_extended_properties) (ConfigurationFacade* self, gboolean display);
	gboolean (*get_display_photo_ratings) (ConfigurationFacade* self);
	void (*set_display_photo_ratings) (ConfigurationFacade* self, gboolean display);
	gboolean (*get_display_photo_tags) (ConfigurationFacade* self);
	void (*set_display_photo_tags) (ConfigurationFacade* self, gboolean display);
	gboolean (*get_display_photo_titles) (ConfigurationFacade* self);
	void (*set_display_photo_titles) (ConfigurationFacade* self, gboolean display);
	void (*get_event_photos_sort) (ConfigurationFacade* self, gboolean* sort_order, gint* sort_by);
	void (*set_event_photos_sort) (ConfigurationFacade* self, gboolean sort_order, gint sort_by);
	gboolean (*get_events_sort_ascending) (ConfigurationFacade* self);
	void (*set_events_sort_ascending) (ConfigurationFacade* self, gboolean sort);
	gchar* (*get_external_photo_app) (ConfigurationFacade* self);
	void (*set_external_photo_app) (ConfigurationFacade* self, const gchar* external_photo_app);
	gchar* (*get_external_raw_app) (ConfigurationFacade* self);
	void (*set_external_raw_app) (ConfigurationFacade* self, const gchar* external_raw_app);
	RawDeveloper (*get_default_raw_developer) (ConfigurationFacade* self);
	void (*set_default_raw_developer) (ConfigurationFacade* self, RawDeveloper d);
	gboolean (*get_hide_photos_already_imported) (ConfigurationFacade* self);
	void (*set_hide_photos_already_imported) (ConfigurationFacade* self, gboolean hide_imported);
	gchar* (*get_import_dir) (ConfigurationFacade* self);
	void (*set_import_dir) (ConfigurationFacade* self, const gchar* import_dir);
	gboolean (*get_keep_relativity) (ConfigurationFacade* self);
	void (*set_keep_relativity) (ConfigurationFacade* self, gboolean keep_relativity);
	gchar* (*get_last_used_service) (ConfigurationFacade* self);
	void (*set_last_used_service) (ConfigurationFacade* self, const gchar* service_name);
	void (*get_library_photos_sort) (ConfigurationFacade* self, gboolean* sort_order, gint* sort_by);
	void (*set_library_photos_sort) (ConfigurationFacade* self, gboolean sort_order, gint sort_by);
	void (*get_library_window_state) (ConfigurationFacade* self, gboolean* maximize, Dimensions* dimensions);
	void (*set_library_window_state) (ConfigurationFacade* self, gboolean maximize, Dimensions* dimensions);
	gboolean (*get_modify_originals) (ConfigurationFacade* self);
	void (*set_modify_originals) (ConfigurationFacade* self, gboolean modify_originals);
	gint (*get_photo_thumbnail_scale) (ConfigurationFacade* self);
	void (*set_photo_thumbnail_scale) (ConfigurationFacade* self, gint scale);
	gdouble (*get_printing_content_height) (ConfigurationFacade* self);
	void (*set_printing_content_height) (ConfigurationFacade* self, gdouble content_height);
	gint (*get_printing_content_layout) (ConfigurationFacade* self);
	void (*set_printing_content_layout) (ConfigurationFacade* self, gint layout_code);
	gint (*get_printing_content_ppi) (ConfigurationFacade* self);
	void (*set_printing_content_ppi) (ConfigurationFacade* self, gint content_ppi);
	gint (*get_printing_content_units) (ConfigurationFacade* self);
	void (*set_printing_content_units) (ConfigurationFacade* self, gint units_code);
	gdouble (*get_printing_content_width) (ConfigurationFacade* self);
	void (*set_printing_content_width) (ConfigurationFacade* self, gdouble content_width);
	gint (*get_printing_images_per_page) (ConfigurationFacade* self);
	void (*set_printing_images_per_page) (ConfigurationFacade* self, gint images_per_page_code);
	gboolean (*get_printing_match_aspect_ratio) (ConfigurationFacade* self);
	void (*set_printing_match_aspect_ratio) (ConfigurationFacade* self, gboolean match_aspect_ratio);
	gboolean (*get_printing_print_titles) (ConfigurationFacade* self);
	void (*set_printing_print_titles) (ConfigurationFacade* self, gboolean print_titles);
	gint (*get_printing_size_selection) (ConfigurationFacade* self);
	void (*set_printing_size_selection) (ConfigurationFacade* self, gint size_code);
	gchar* (*get_printing_titles_font) (ConfigurationFacade* self);
	void (*set_printing_titles_font) (ConfigurationFacade* self, const gchar* font_name);
	gboolean (*get_show_welcome_dialog) (ConfigurationFacade* self);
	void (*set_show_welcome_dialog) (ConfigurationFacade* self, gboolean show);
	gint (*get_sidebar_position) (ConfigurationFacade* self);
	void (*set_sidebar_position) (ConfigurationFacade* self, gint position);
	gdouble (*get_slideshow_delay) (ConfigurationFacade* self);
	void (*set_slideshow_delay) (ConfigurationFacade* self, gdouble delay);
	gdouble (*get_slideshow_transition_delay) (ConfigurationFacade* self);
	void (*set_slideshow_transition_delay) (ConfigurationFacade* self, gdouble delay);
	gchar* (*get_slideshow_transition_effect_id) (ConfigurationFacade* self);
	void (*set_slideshow_transition_effect_id) (ConfigurationFacade* self, const gchar* id);
	gboolean (*get_use_24_hour_time) (ConfigurationFacade* self);
	void (*set_use_24_hour_time) (ConfigurationFacade* self, gboolean use_24_hour_time);
	gboolean (*get_use_lowercase_filenames) (ConfigurationFacade* self);
	void (*set_use_lowercase_filenames) (ConfigurationFacade* self, gboolean b);
	gint (*get_video_interpreter_state_cookie) (ConfigurationFacade* self);
	void (*set_video_interpreter_state_cookie) (ConfigurationFacade* self, gint state_cookie);
	gboolean (*get_plugin_bool) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, gboolean def);
	void (*set_plugin_bool) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, gboolean val);
	gdouble (*get_plugin_double) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, gdouble def);
	void (*set_plugin_double) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, gdouble val);
	gint (*get_plugin_int) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, gint def);
	void (*set_plugin_int) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, gint val);
	gchar* (*get_plugin_string) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, const gchar* def);
	void (*set_plugin_string) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key, const gchar* val);
	void (*unset_plugin_key) (ConfigurationFacade* self, const gchar* domain, const gchar* id, const gchar* key);
	FuzzyPropertyState (*is_plugin_enabled) (ConfigurationFacade* self, const gchar* id);
	void (*set_plugin_enabled) (ConfigurationFacade* self, const gchar* id, gboolean enabled);
};

struct _ConfigFacade {
	ConfigurationFacade parent_instance;
	ConfigFacadePrivate * priv;
};

struct _ConfigFacadeClass {
	ConfigurationFacadeClass parent_class;
};

struct _ConfigFacadePrivate {
	gchar* bg_color;
	gchar* selected_color;
	gchar* unselected_color;
	gchar* unfocused_selected_color;
	gchar* border_color;
};

typedef enum  {
	CONFIGURABLE_PROPERTY_AUTO_IMPORT_FROM_LIBRARY = 0,
	CONFIGURABLE_PROPERTY_BG_COLOR_NAME,
	CONFIGURABLE_PROPERTY_COMMIT_METADATA_TO_MASTERS,
	CONFIGURABLE_PROPERTY_DESKTOP_BACKGROUND_FILE,
	CONFIGURABLE_PROPERTY_DESKTOP_BACKGROUND_MODE,
	CONFIGURABLE_PROPERTY_DIRECTORY_PATTERN,
	CONFIGURABLE_PROPERTY_DIRECTORY_PATTERN_CUSTOM,
	CONFIGURABLE_PROPERTY_DIRECT_WINDOW_HEIGHT,
	CONFIGURABLE_PROPERTY_DIRECT_WINDOW_MAXIMIZE,
	CONFIGURABLE_PROPERTY_DIRECT_WINDOW_WIDTH,
	CONFIGURABLE_PROPERTY_DISPLAY_BASIC_PROPERTIES,
	CONFIGURABLE_PROPERTY_DISPLAY_EXTENDED_PROPERTIES,
	CONFIGURABLE_PROPERTY_DISPLAY_PHOTO_RATINGS,
	CONFIGURABLE_PROPERTY_DISPLAY_PHOTO_TAGS,
	CONFIGURABLE_PROPERTY_DISPLAY_PHOTO_TITLES,
	CONFIGURABLE_PROPERTY_EVENT_PHOTOS_SORT_ASCENDING,
	CONFIGURABLE_PROPERTY_EVENT_PHOTOS_SORT_BY,
	CONFIGURABLE_PROPERTY_EVENTS_SORT_ASCENDING,
	CONFIGURABLE_PROPERTY_EXTERNAL_PHOTO_APP,
	CONFIGURABLE_PROPERTY_EXTERNAL_RAW_APP,
	CONFIGURABLE_PROPERTY_HIDE_PHOTOS_ALREADY_IMPORTED,
	CONFIGURABLE_PROPERTY_IMPORT_DIR,
	CONFIGURABLE_PROPERTY_KEEP_RELATIVITY,
	CONFIGURABLE_PROPERTY_LAST_USED_SERVICE,
	CONFIGURABLE_PROPERTY_LIBRARY_PHOTOS_SORT_ASCENDING,
	CONFIGURABLE_PROPERTY_LIBRARY_PHOTOS_SORT_BY,
	CONFIGURABLE_PROPERTY_LIBRARY_WINDOW_HEIGHT,
	CONFIGURABLE_PROPERTY_LIBRARY_WINDOW_MAXIMIZE,
	CONFIGURABLE_PROPERTY_LIBRARY_WINDOW_WIDTH,
	CONFIGURABLE_PROPERTY_MODIFY_ORIGINALS,
	CONFIGURABLE_PROPERTY_PHOTO_THUMBNAIL_SCALE,
	CONFIGURABLE_PROPERTY_PRINTING_CONTENT_HEIGHT,
	CONFIGURABLE_PROPERTY_PRINTING_CONTENT_LAYOUT,
	CONFIGURABLE_PROPERTY_PRINTING_CONTENT_PPI,
	CONFIGURABLE_PROPERTY_PRINTING_CONTENT_UNITS,
	CONFIGURABLE_PROPERTY_PRINTING_CONTENT_WIDTH,
	CONFIGURABLE_PROPERTY_PRINTING_IMAGES_PER_PAGE,
	CONFIGURABLE_PROPERTY_PRINTING_MATCH_ASPECT_RATIO,
	CONFIGURABLE_PROPERTY_PRINTING_PRINT_TITLES,
	CONFIGURABLE_PROPERTY_PRINTING_SIZE_SELECTION,
	CONFIGURABLE_PROPERTY_PRINTING_TITLES_FONT,
	CONFIGURABLE_PROPERTY_RAW_DEVELOPER_DEFAULT,
	CONFIGURABLE_PROPERTY_SHOW_WELCOME_DIALOG,
	CONFIGURABLE_PROPERTY_SIDEBAR_POSITION,
	CONFIGURABLE_PROPERTY_SLIDESHOW_DELAY,
	CONFIGURABLE_PROPERTY_SLIDESHOW_TRANSITION_DELAY,
	CONFIGURABLE_PROPERTY_SLIDESHOW_TRANSITION_EFFECT_ID,
	CONFIGURABLE_PROPERTY_USE_24_HOUR_TIME,
	CONFIGURABLE_PROPERTY_USE_LOWERCASE_FILENAMES,
	CONFIGURABLE_PROPERTY_VIDEO_INTERPRETER_STATE_COOKIE,
	CONFIGURABLE_PROPERTY_NUM_PROPERTIES
} ConfigurableProperty;

typedef enum  {
	CONFIGURATION_ERROR_PROPERTY_HAS_NO_VALUE,
	CONFIGURATION_ERROR_ENGINE_ERROR
} ConfigurationError;
#define CONFIGURATION_ERROR configuration_error_quark ()
struct _ConfigurationEngineIface {
	GTypeInterface parent_iface;
	gchar* (*get_name) (ConfigurationEngine* self);
	gint (*get_int_property) (ConfigurationEngine* self, ConfigurableProperty p, GError** error);
	void (*set_int_property) (ConfigurationEngine* self, ConfigurableProperty p, gint val, GError** error);
	gchar* (*get_string_property) (ConfigurationEngine* self, ConfigurableProperty p, GError** error);
	void (*set_string_property) (ConfigurationEngine* self, ConfigurableProperty p, const gchar* val, GError** error);
	gboolean (*get_bool_property) (ConfigurationEngine* self, ConfigurableProperty p, GError** error);
	void (*set_bool_property) (ConfigurationEngine* self, ConfigurableProperty p, gboolean val, GError** error);
	gdouble (*get_double_property) (ConfigurationEngine* self, ConfigurableProperty p, GError** error);
	void (*set_double_property) (ConfigurationEngine* self, ConfigurableProperty p, gdouble val, GError** error);
	gboolean (*get_plugin_bool) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, gboolean def);
	void (*set_plugin_bool) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, gboolean val);
	gdouble (*get_plugin_double) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, gdouble def);
	void (*set_plugin_double) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, gdouble val);
	gint (*get_plugin_int) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, gint def);
	void (*set_plugin_int) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, gint val);
	gchar* (*get_plugin_string) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, const gchar* def);
	void (*set_plugin_string) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key, const gchar* val);
	void (*unset_plugin_key) (ConfigurationEngine* self, const gchar* domain, const gchar* id, const gchar* key);
	FuzzyPropertyState (*is_plugin_enabled) (ConfigurationEngine* self, const gchar* id);
	void (*set_plugin_enabled) (ConfigurationEngine* self, const gchar* id, gboolean enabled);
};


static gpointer config_facade_parent_class = NULL;
static ConfigFacade* config_facade_instance;
static ConfigFacade* config_facade_instance = NULL;

GType configuration_facade_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType raw_developer_get_type (void) G_GNUC_CONST;
GType fuzzy_property_state_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
#define CONFIG_FACADE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONFIG_TYPE_FACADE, ConfigFacadePrivate))
enum  {
	CONFIG_FACADE_DUMMY_PROPERTY
};
#define CONFIG_FACADE_SLIDESHOW_DELAY_MAX 30.0
#define CONFIG_FACADE_SLIDESHOW_DELAY_MIN 1.0
#define CONFIG_FACADE_SLIDESHOW_DELAY_DEFAULT 3.0
#define CONFIG_FACADE_SLIDESHOW_TRANSITION_DELAY_MAX 1.0
#define CONFIG_FACADE_SLIDESHOW_TRANSITION_DELAY_MIN 0.1
#define CONFIG_FACADE_SLIDESHOW_TRANSITION_DELAY_DEFAULT 0.3
#define CONFIG_FACADE_WIDTH_DEFAULT 1024
#define CONFIG_FACADE_HEIGHT_DEFAULT 768
#define CONFIG_FACADE_SIDEBAR_MIN_POSITION 180
#define CONFIG_FACADE_SIDEBAR_MAX_POSITION 1000
#define CONFIG_FACADE_DEFAULT_BG_COLOR "#444"
#define CONFIG_FACADE_NO_VIDEO_INTERPRETER_STATE (-1)
#define CONFIG_FACADE_BLACK_THRESHOLD ((guint) 40000)
#define CONFIG_FACADE_DARK_SELECTED_COLOR "#0AD"
#define CONFIG_FACADE_LIGHT_SELECTED_COLOR "#2DF"
#define CONFIG_FACADE_DARK_UNSELECTED_COLOR "#000"
#define CONFIG_FACADE_LIGHT_UNSELECTED_COLOR "#FFF"
#define CONFIG_FACADE_DARK_BORDER_COLOR "#999"
#define CONFIG_FACADE_LIGHT_BORDER_COLOR "#AAA"
#define CONFIG_FACADE_DARK_UNFOCUSED_SELECTED_COLOR "#6fc4dd"
#define CONFIG_FACADE_LIGHT_UNFOCUSED_SELECTED_COLOR "#99efff"
static ConfigFacade* config_facade_new (void);
static ConfigFacade* config_facade_construct (GType object_type);
HybridConfigurationEngine* hybrid_configuration_engine_new (void);
HybridConfigurationEngine* hybrid_configuration_engine_construct (GType object_type);
GType hybrid_configuration_engine_get_type (void) G_GNUC_CONST;
GType configurable_property_get_type (void) G_GNUC_CONST;
GQuark configuration_error_quark (void);
GType configuration_engine_get_type (void) G_GNUC_CONST;
ConfigurationFacade* configuration_facade_construct (GType object_type, ConfigurationEngine* engine);
static void config_facade_on_color_name_changed (ConfigFacade* self);
static void _config_facade_on_color_name_changed_configuration_facade_bg_color_name_changed (ConfigurationFacade* _sender, gpointer self);
ConfigFacade* config_facade_get_instance (void);
static void config_facade_set_text_colors (ConfigFacade* self, GdkColor* bg_color);
static void config_facade_get_colors (ConfigFacade* self);
gchar* configuration_facade_get_bg_color_name (ConfigurationFacade* self);
gboolean is_color_parsable (const gchar* spec);
void parse_color (const gchar* spec, GdkColor* result);
void config_facade_get_bg_color (ConfigFacade* self, GdkColor* result);
gboolean is_string_empty (const gchar* s);
void config_facade_get_selected_color (ConfigFacade* self, gboolean in_focus, GdkColor* result);
void config_facade_get_unselected_color (ConfigFacade* self, GdkColor* result);
void config_facade_get_border_color (ConfigFacade* self, GdkColor* result);
void config_facade_set_bg_color (ConfigFacade* self, GdkColor* color);
void configuration_facade_set_bg_color_name (ConfigurationFacade* self, const gchar* color_name);
void config_facade_commit_bg_color (ConfigFacade* self);
static void config_facade_finalize (GObject* obj);
void config_preconfigure (void);
void config_init (GError** error);
void config_terminate (void);


static void _config_facade_on_color_name_changed_configuration_facade_bg_color_name_changed (ConfigurationFacade* _sender, gpointer self) {
	config_facade_on_color_name_changed (self);
}


static ConfigFacade* config_facade_construct (GType object_type) {
	ConfigFacade * self = NULL;
	HybridConfigurationEngine* _tmp0_ = NULL;
	HybridConfigurationEngine* _tmp1_;
	_tmp0_ = hybrid_configuration_engine_new ();
	_tmp1_ = _tmp0_;
	self = (ConfigFacade*) configuration_facade_construct (object_type, CONFIGURATION_ENGINE (_tmp1_));
	_g_object_unref0 (_tmp1_);
	g_signal_connect_object (CONFIGURATION_FACADE (self), "bg-color-name-changed", (GCallback) _config_facade_on_color_name_changed_configuration_facade_bg_color_name_changed, self, 0);
	return self;
}


static ConfigFacade* config_facade_new (void) {
	return config_facade_construct (CONFIG_TYPE_FACADE);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


ConfigFacade* config_facade_get_instance (void) {
	ConfigFacade* result = NULL;
	ConfigFacade* _tmp1_;
	if (config_facade_instance == NULL) {
		ConfigFacade* _tmp0_ = NULL;
		_tmp0_ = config_facade_new ();
		_g_object_unref0 (config_facade_instance);
		config_facade_instance = _tmp0_;
	}
	_tmp1_ = _g_object_ref0 (config_facade_instance);
	result = _tmp1_;
	return result;
}


static void config_facade_on_color_name_changed (ConfigFacade* self) {
	g_return_if_fail (CONFIG_IS_FACADE (self));
	g_signal_emit_by_name (self, "colors-changed");
}


static void config_facade_set_text_colors (ConfigFacade* self, GdkColor* bg_color) {
	g_return_if_fail (CONFIG_IS_FACADE (self));
	if ((*bg_color).red > CONFIG_FACADE_BLACK_THRESHOLD) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = g_strdup (CONFIG_FACADE_DARK_SELECTED_COLOR);
		_g_free0 (self->priv->selected_color);
		self->priv->selected_color = _tmp0_;
		_tmp1_ = g_strdup (CONFIG_FACADE_DARK_UNSELECTED_COLOR);
		_g_free0 (self->priv->unselected_color);
		self->priv->unselected_color = _tmp1_;
		_tmp2_ = g_strdup (CONFIG_FACADE_DARK_UNFOCUSED_SELECTED_COLOR);
		_g_free0 (self->priv->unfocused_selected_color);
		self->priv->unfocused_selected_color = _tmp2_;
		_tmp3_ = g_strdup (CONFIG_FACADE_DARK_BORDER_COLOR);
		_g_free0 (self->priv->border_color);
		self->priv->border_color = _tmp3_;
	} else {
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp4_ = g_strdup (CONFIG_FACADE_LIGHT_SELECTED_COLOR);
		_g_free0 (self->priv->selected_color);
		self->priv->selected_color = _tmp4_;
		_tmp5_ = g_strdup (CONFIG_FACADE_LIGHT_UNSELECTED_COLOR);
		_g_free0 (self->priv->unselected_color);
		self->priv->unselected_color = _tmp5_;
		_tmp6_ = g_strdup (CONFIG_FACADE_LIGHT_UNFOCUSED_SELECTED_COLOR);
		_g_free0 (self->priv->unfocused_selected_color);
		self->priv->unfocused_selected_color = _tmp6_;
		_tmp7_ = g_strdup (CONFIG_FACADE_LIGHT_BORDER_COLOR);
		_g_free0 (self->priv->border_color);
		self->priv->border_color = _tmp7_;
	}
}


static void config_facade_get_colors (ConfigFacade* self) {
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	GdkColor _tmp3_ = {0};
	GdkColor _tmp4_ = {0};
	g_return_if_fail (CONFIG_IS_FACADE (self));
	_tmp0_ = CONFIGURATION_FACADE_CLASS (config_facade_parent_class)->get_bg_color_name (CONFIGURATION_FACADE (self));
	_g_free0 (self->priv->bg_color);
	self->priv->bg_color = _tmp0_;
	_tmp1_ = is_color_parsable (self->priv->bg_color);
	if (!_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (CONFIG_FACADE_DEFAULT_BG_COLOR);
		_g_free0 (self->priv->bg_color);
		self->priv->bg_color = _tmp2_;
	}
	parse_color (self->priv->bg_color, &_tmp3_);
	_tmp4_ = _tmp3_;
	config_facade_set_text_colors (self, &_tmp4_);
}


void config_facade_get_bg_color (ConfigFacade* self, GdkColor* result) {
	gboolean _tmp0_;
	GdkColor _tmp1_ = {0};
	GdkColor _tmp2_ = {0};
	g_return_if_fail (CONFIG_IS_FACADE (self));
	_tmp0_ = is_string_empty (self->priv->bg_color);
	if (_tmp0_) {
		config_facade_get_colors (self);
	}
	parse_color (self->priv->bg_color, &_tmp1_);
	_tmp2_ = _tmp1_;
	*result = _tmp2_;
	return;
}


void config_facade_get_selected_color (ConfigFacade* self, gboolean in_focus, GdkColor* result) {
	g_return_if_fail (CONFIG_IS_FACADE (self));
	if (in_focus) {
		gboolean _tmp0_;
		GdkColor _tmp1_ = {0};
		GdkColor _tmp2_ = {0};
		_tmp0_ = is_string_empty (self->priv->selected_color);
		if (_tmp0_) {
			config_facade_get_colors (self);
		}
		parse_color (self->priv->selected_color, &_tmp1_);
		_tmp2_ = _tmp1_;
		*result = _tmp2_;
		return;
	} else {
		gboolean _tmp3_;
		GdkColor _tmp4_ = {0};
		GdkColor _tmp5_ = {0};
		_tmp3_ = is_string_empty (self->priv->unfocused_selected_color);
		if (_tmp3_) {
			config_facade_get_colors (self);
		}
		parse_color (self->priv->unfocused_selected_color, &_tmp4_);
		_tmp5_ = _tmp4_;
		*result = _tmp5_;
		return;
	}
}


void config_facade_get_unselected_color (ConfigFacade* self, GdkColor* result) {
	gboolean _tmp0_;
	GdkColor _tmp1_ = {0};
	GdkColor _tmp2_ = {0};
	g_return_if_fail (CONFIG_IS_FACADE (self));
	_tmp0_ = is_string_empty (self->priv->unselected_color);
	if (_tmp0_) {
		config_facade_get_colors (self);
	}
	parse_color (self->priv->unselected_color, &_tmp1_);
	_tmp2_ = _tmp1_;
	*result = _tmp2_;
	return;
}


void config_facade_get_border_color (ConfigFacade* self, GdkColor* result) {
	gboolean _tmp0_;
	GdkColor _tmp1_ = {0};
	GdkColor _tmp2_ = {0};
	g_return_if_fail (CONFIG_IS_FACADE (self));
	_tmp0_ = is_string_empty (self->priv->border_color);
	if (_tmp0_) {
		config_facade_get_colors (self);
	}
	parse_color (self->priv->border_color, &_tmp1_);
	_tmp2_ = _tmp1_;
	*result = _tmp2_;
	return;
}


void config_facade_set_bg_color (ConfigFacade* self, GdkColor* color) {
	gchar* _tmp0_ = NULL;
	g_return_if_fail (CONFIG_IS_FACADE (self));
	_tmp0_ = gdk_color_to_string (color);
	_g_free0 (self->priv->bg_color);
	self->priv->bg_color = _tmp0_;
	configuration_facade_set_bg_color_name (CONFIGURATION_FACADE (self), self->priv->bg_color);
	config_facade_set_text_colors (self, color);
}


void config_facade_commit_bg_color (ConfigFacade* self) {
	g_return_if_fail (CONFIG_IS_FACADE (self));
	CONFIGURATION_FACADE_CLASS (config_facade_parent_class)->set_bg_color_name (CONFIGURATION_FACADE (self), self->priv->bg_color);
}


static void config_facade_class_init (ConfigFacadeClass * klass) {
	config_facade_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ConfigFacadePrivate));
	G_OBJECT_CLASS (klass)->finalize = config_facade_finalize;
	g_signal_new ("colors_changed", CONFIG_TYPE_FACADE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void config_facade_instance_init (ConfigFacade * self) {
	self->priv = CONFIG_FACADE_GET_PRIVATE (self);
	self->priv->bg_color = NULL;
	self->priv->selected_color = NULL;
	self->priv->unselected_color = NULL;
	self->priv->unfocused_selected_color = NULL;
	self->priv->border_color = NULL;
}


static void config_facade_finalize (GObject* obj) {
	ConfigFacade * self;
	self = CONFIG_FACADE (obj);
	_g_free0 (self->priv->bg_color);
	_g_free0 (self->priv->selected_color);
	_g_free0 (self->priv->unselected_color);
	_g_free0 (self->priv->unfocused_selected_color);
	_g_free0 (self->priv->border_color);
	G_OBJECT_CLASS (config_facade_parent_class)->finalize (obj);
}


GType config_facade_get_type (void) {
	static volatile gsize config_facade_type_id__volatile = 0;
	if (g_once_init_enter (&config_facade_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ConfigFacadeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_facade_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConfigFacade), 0, (GInstanceInitFunc) config_facade_instance_init, NULL };
		GType config_facade_type_id;
		config_facade_type_id = g_type_register_static (TYPE_CONFIGURATION_FACADE, "ConfigFacade", &g_define_type_info, 0);
		g_once_init_leave (&config_facade_type_id__volatile, config_facade_type_id);
	}
	return config_facade_type_id__volatile;
}


void config_preconfigure (void) {
}


void config_init (GError** error) {
}


void config_terminate (void) {
}



