/* EventTable.c generated by valac 0.12.0, the Vala compiler
 * generated from EventTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>
#include <gee.h>


#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_EVENT_ROW (event_row_get_type ())
typedef struct _EventRow EventRow;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_EVENT_TABLE (event_table_get_type ())
#define EVENT_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_TABLE, EventTable))
#define EVENT_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_TABLE, EventTableClass))
#define IS_EVENT_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_TABLE))
#define IS_EVENT_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_TABLE))
#define EVENT_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_TABLE, EventTableClass))

typedef struct _EventTable EventTable;
typedef struct _EventTableClass EventTableClass;
typedef struct _EventTablePrivate EventTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_MEDIA_COLLECTION_REGISTRY (media_collection_registry_get_type ())
#define MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry))
#define MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))
#define IS_MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_COLLECTION_REGISTRY))
#define IS_MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_COLLECTION_REGISTRY))
#define MEDIA_COLLECTION_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))

typedef struct _MediaCollectionRegistry MediaCollectionRegistry;
typedef struct _MediaCollectionRegistryClass MediaCollectionRegistryClass;
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _EventID {
	gint64 id;
};

struct _EventRow {
	EventID event_id;
	gchar* name;
	time_t time_created;
	gchar* primary_source_id;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _EventTable {
	DatabaseTable parent_instance;
	EventTablePrivate * priv;
};

struct _EventTableClass {
	DatabaseTableClass parent_class;
};

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer event_table_parent_class = NULL;
static EventTable* event_table_instance;
static EventTable* event_table_instance = NULL;
extern sqlite3* database_table_db;

GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
#define EVENT_ID_INVALID ((gint64) (-1))
void event_id_init (EventID *self, gint64 id);
gboolean event_id_is_invalid (EventID *self);
gboolean event_id_is_valid (EventID *self);
GType event_row_get_type (void) G_GNUC_CONST;
EventRow* event_row_dup (const EventRow* self);
void event_row_free (EventRow* self);
void event_row_copy (const EventRow* self, EventRow* dest);
void event_row_destroy (EventRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType event_table_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_TABLE_DUMMY_PROPERTY
};
static EventTable* event_table_new (void);
static EventTable* event_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
EventTable* event_table_get_instance (void);
static gchar* event_table_source_id_upgrade (EventTable* self, gint64 primary_photo_id, const gchar* primary_source_id);
gpointer media_collection_registry_ref (gpointer instance);
void media_collection_registry_unref (gpointer instance);
GParamSpec* param_spec_media_collection_registry (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_collection_registry (GValue* value, gpointer v_object);
void value_take_media_collection_registry (GValue* value, gpointer v_object);
gpointer value_get_media_collection_registry (const GValue* value);
GType media_collection_registry_get_type (void) G_GNUC_CONST;
MediaCollectionRegistry* media_collection_registry_get_instance (void);
gboolean media_collection_registry_is_valid_source_id (MediaCollectionRegistry* self, const gchar* source_id);
#define PHOTO_ID_INVALID ((gint64) (-1))
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
void photo_id_init (PhotoID *self, gint64 id);
GQuark database_error_quark (void);
void event_table_create (EventTable* self, const gchar* primary_source_id, EventRow* result, GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method, gint res, GError** error);
void event_table_create_from_row (EventTable* self, EventRow* row, EventID* result);
EventRow* event_table_get_row (EventTable* self, EventID* event_id);
void event_table_remove (EventTable* self, EventID* event_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
GeeArrayList* event_table_get_events (EventTable* self);
gboolean event_table_rename (EventTable* self, EventID* event_id, const gchar* name);
gboolean database_table_update_text_by_id (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text);
gchar* event_table_get_name (EventTable* self, EventID* event_id);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
gchar* event_table_get_primary_source_id (EventTable* self, EventID* event_id);
gboolean event_table_set_primary_source_id (EventTable* self, EventID* event_id, const gchar* primary_source_id);
time_t event_table_get_time_created (EventTable* self, EventID* event_id);
static void event_table_finalize (DatabaseTable* obj);


void event_id_init (EventID *self, gint64 id) {
	memset (self, 0, sizeof (EventID));
	(*self).id = id;
}


gboolean event_id_is_invalid (EventID *self) {
	gboolean result = FALSE;
	result = (*self).id == EVENT_ID_INVALID;
	return result;
}


gboolean event_id_is_valid (EventID *self) {
	gboolean result = FALSE;
	result = (*self).id != EVENT_ID_INVALID;
	return result;
}


EventID* event_id_dup (const EventID* self) {
	EventID* dup;
	dup = g_new0 (EventID, 1);
	memcpy (dup, self, sizeof (EventID));
	return dup;
}


void event_id_free (EventID* self) {
	g_free (self);
}


GType event_id_get_type (void) {
	static volatile gsize event_id_type_id__volatile = 0;
	if (g_once_init_enter (&event_id_type_id__volatile)) {
		GType event_id_type_id;
		event_id_type_id = g_boxed_type_register_static ("EventID", (GBoxedCopyFunc) event_id_dup, (GBoxedFreeFunc) event_id_free);
		g_once_init_leave (&event_id_type_id__volatile, event_id_type_id);
	}
	return event_id_type_id__volatile;
}


void event_row_copy (const EventRow* self, EventRow* dest) {
	dest->event_id = self->event_id;
	dest->name = g_strdup (self->name);
	dest->time_created = self->time_created;
	dest->primary_source_id = g_strdup (self->primary_source_id);
}


void event_row_destroy (EventRow* self) {
	_g_free0 ((*self).name);
	_g_free0 ((*self).primary_source_id);
}


EventRow* event_row_dup (const EventRow* self) {
	EventRow* dup;
	dup = g_new0 (EventRow, 1);
	event_row_copy (self, dup);
	return dup;
}


void event_row_free (EventRow* self) {
	event_row_destroy (self);
	g_free (self);
}


GType event_row_get_type (void) {
	static volatile gsize event_row_type_id__volatile = 0;
	if (g_once_init_enter (&event_row_type_id__volatile)) {
		GType event_row_type_id;
		event_row_type_id = g_boxed_type_register_static ("EventRow", (GBoxedCopyFunc) event_row_dup, (GBoxedFreeFunc) event_row_free);
		g_once_init_leave (&event_row_type_id__volatile, event_row_type_id);
	}
	return event_row_type_id__volatile;
}


static EventTable* event_table_construct (GType object_type) {
	EventTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	self = (EventTable*) database_table_construct (object_type);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS EventTable (" "id INTEGER PRIMARY KEY, " "name TEXT, " "primary_photo_id INTEGER, " "time_created INTEGER," "primary_source_id TEXT" ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("create photo table", res);
	}
	database_table_set_table_name (DATABASE_TABLE (self), "EventTable");
	_sqlite3_finalize0 (stmt);
	return self;
}


static EventTable* event_table_new (void) {
	return event_table_construct (TYPE_EVENT_TABLE);
}


static gpointer _database_table_ref0 (gpointer self) {
	return self ? database_table_ref (self) : NULL;
}


EventTable* event_table_get_instance (void) {
	EventTable* result = NULL;
	EventTable* _tmp1_;
	if (event_table_instance == NULL) {
		EventTable* _tmp0_ = NULL;
		_tmp0_ = event_table_new ();
		_database_table_unref0 (event_table_instance);
		event_table_instance = _tmp0_;
	}
	_tmp1_ = _database_table_ref0 (event_table_instance);
	result = _tmp1_;
	return result;
}


static gchar* event_table_source_id_upgrade (EventTable* self, gint64 primary_photo_id, const gchar* primary_source_id) {
	gchar* result = NULL;
	MediaCollectionRegistry* _tmp0_ = NULL;
	MediaCollectionRegistry* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), NULL);
	_tmp0_ = media_collection_registry_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = media_collection_registry_is_valid_source_id (_tmp1_, primary_source_id);
	_tmp3_ = _tmp2_;
	_media_collection_registry_unref0 (_tmp1_);
	if (_tmp3_) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (primary_source_id);
		result = _tmp4_;
		return result;
	}
	if (primary_photo_id != PHOTO_ID_INVALID) {
		PhotoID _tmp5_ = {0};
		PhotoID _tmp6_ = {0};
		gchar* _tmp7_ = NULL;
		photo_id_init (&_tmp5_, primary_photo_id);
		_tmp6_ = _tmp5_;
		_tmp7_ = photo_id_upgrade_photo_id_to_source_id (&_tmp6_);
		result = _tmp7_;
		return result;
	}
	result = NULL;
	return result;
}


void event_table_create (EventTable* self, const gchar* primary_source_id, EventRow* result, GError** error) {
	gboolean _tmp0_ = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint res;
	gulong _tmp3_;
	time_t time_created;
	gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	EventRow row = {0};
	gint64 _tmp8_;
	EventID _tmp9_ = {0};
	EventID _tmp10_ = {0};
	gchar* _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_EVENT_TABLE (self));
	if (primary_source_id != NULL) {
		_tmp0_ = g_strcmp0 (primary_source_id, "") != 0;
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
	_tmp2_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO EventTable (primary_source_id, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = now_sec ();
	time_created = (time_t) _tmp3_;
	_tmp4_ = g_strdup (primary_source_id);
	_tmp5_ = sqlite3_bind_text (stmt, 1, _tmp4_, -1, g_free);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_bind_int64 (stmt, 2, (gint64) time_created);
	res = _tmp6_;
	g_assert (res == SQLITE_OK);
	_tmp7_ = sqlite3_step (stmt);
	res = _tmp7_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("EventTable.create", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	memset (&row, 0, sizeof (EventRow));
	_tmp8_ = sqlite3_last_insert_rowid (database_table_db);
	event_id_init (&_tmp9_, _tmp8_);
	_tmp10_ = _tmp9_;
	row.event_id = _tmp10_;
	_g_free0 (row.name);
	row.name = NULL;
	_tmp11_ = g_strdup (primary_source_id);
	_g_free0 (row.primary_source_id);
	row.primary_source_id = _tmp11_;
	row.time_created = time_created;
	*result = row;
	_sqlite3_finalize0 (stmt);
	return;
}


void event_table_create_from_row (EventTable* self, EventRow* row, EventID* result) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint64 _tmp11_;
	EventID _tmp12_ = {0};
	EventID _tmp13_ = {0};
	g_return_if_fail (IS_EVENT_TABLE (self));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO EventTable (name, primary_photo_id, primary_source_id, tim" \
"e_created) VALUES (?, ?, ?, ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = g_strdup ((*row).name);
	_tmp3_ = sqlite3_bind_text (stmt, 1, _tmp2_, -1, g_free);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_bind_int64 (stmt, 2, PHOTO_ID_INVALID);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = g_strdup ((*row).primary_source_id);
	_tmp6_ = sqlite3_bind_text (stmt, 3, _tmp5_, -1, g_free);
	res = _tmp6_;
	g_assert (res == SQLITE_OK);
	_tmp7_ = sqlite3_bind_int64 (stmt, 4, (gint64) (*row).time_created);
	res = _tmp7_;
	g_assert (res == SQLITE_OK);
	_tmp8_ = sqlite3_step (stmt);
	res = _tmp8_;
	if (res != SQLITE_DONE) {
		EventID _tmp9_ = {0};
		EventID _tmp10_ = {0};
		database_table_fatal ("Event create_from_row", res);
		event_id_init (&_tmp9_, EVENT_ID_INVALID);
		_tmp10_ = _tmp9_;
		*result = _tmp10_;
		_sqlite3_finalize0 (stmt);
		return;
	}
	_tmp11_ = sqlite3_last_insert_rowid (database_table_db);
	event_id_init (&_tmp12_, _tmp11_);
	_tmp13_ = _tmp12_;
	*result = _tmp13_;
	_sqlite3_finalize0 (stmt);
	return;
}


static gpointer _event_row_dup0 (gpointer self) {
	return self ? event_row_dup (self) : NULL;
}


EventRow* event_table_get_row (EventTable* self, EventID* event_id) {
	EventRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gint _tmp3_;
	EventRow row = {0};
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp8_;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint64 _tmp11_;
	EventRow _tmp12_;
	EventRow* _tmp13_;
	EventRow* _tmp14_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT name, primary_photo_id, primary_source_id, time_created FROM Ev" \
"entTable WHERE id=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, (*event_id).id);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_step (stmt);
	if (_tmp3_ != SQLITE_ROW) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	memset (&row, 0, sizeof (EventRow));
	row.event_id = *event_id;
	_tmp4_ = sqlite3_column_text (stmt, 0);
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (row.name);
	row.name = _tmp5_;
	if (row.name != NULL) {
		gint _tmp7_;
		_tmp7_ = strlen (row.name);
		_tmp6_ = _tmp7_ == 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		_g_free0 (row.name);
		row.name = NULL;
	}
	_tmp8_ = sqlite3_column_int64 (stmt, 1);
	_tmp9_ = sqlite3_column_text (stmt, 2);
	_tmp10_ = event_table_source_id_upgrade (self, _tmp8_, _tmp9_);
	_g_free0 (row.primary_source_id);
	row.primary_source_id = _tmp10_;
	_tmp11_ = sqlite3_column_int64 (stmt, 3);
	row.time_created = (time_t) _tmp11_;
	_tmp12_ = row;
	_tmp13_ = _event_row_dup0 (&_tmp12_);
	_tmp14_ = _tmp13_;
	event_row_destroy (&_tmp12_);
	result = _tmp14_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void event_table_remove (EventTable* self, EventID* event_id, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_EVENT_TABLE (self));
	database_table_delete_by_id (DATABASE_TABLE (self), (*event_id).id, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


GeeArrayList* event_table_get_events (EventTable* self) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	GeeArrayList* _tmp2_ = NULL;
	GeeArrayList* event_rows;
	g_return_val_if_fail (IS_EVENT_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT id, name, primary_photo_id, primary_source_id, time_created FRO" \
"M EventTable", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = gee_array_list_new (TYPE_EVENT_ROW, (GBoxedCopyFunc) event_row_dup, event_row_free, NULL);
	event_rows = _tmp2_;
	{
		gboolean _tmp3_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gint _tmp4_;
			EventRow row = {0};
			gint64 _tmp5_;
			EventID _tmp6_ = {0};
			EventID _tmp7_ = {0};
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			gint64 _tmp10_;
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gint64 _tmp13_;
			if (!_tmp3_) {
			}
			_tmp3_ = FALSE;
			_tmp4_ = sqlite3_step (stmt);
			res = _tmp4_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					database_table_fatal ("get_events", res);
					break;
				}
			}
			memset (&row, 0, sizeof (EventRow));
			_tmp5_ = sqlite3_column_int64 (stmt, 0);
			event_id_init (&_tmp6_, _tmp5_);
			_tmp7_ = _tmp6_;
			row.event_id = _tmp7_;
			_tmp8_ = sqlite3_column_text (stmt, 1);
			_tmp9_ = g_strdup (_tmp8_);
			_g_free0 (row.name);
			row.name = _tmp9_;
			_tmp10_ = sqlite3_column_int64 (stmt, 2);
			_tmp11_ = sqlite3_column_text (stmt, 3);
			_tmp12_ = event_table_source_id_upgrade (self, _tmp10_, _tmp11_);
			_g_free0 (row.primary_source_id);
			row.primary_source_id = _tmp12_;
			_tmp13_ = sqlite3_column_int64 (stmt, 4);
			row.time_created = (time_t) _tmp13_;
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (event_rows), &row);
			event_row_destroy (&row);
		}
	}
	result = event_rows;
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean event_table_rename (EventTable* self, EventID* event_id, const gchar* name) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), FALSE);
	if (name != NULL) {
		_tmp0_ = name;
	} else {
		_tmp0_ = "";
	}
	_tmp1_ = database_table_update_text_by_id (DATABASE_TABLE (self), (*event_id).id, "name", _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* event_table_get_name (EventTable* self, EventID* event_id) {
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* name;
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp7_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), NULL);
	_tmp1_ = database_table_select_by_id (DATABASE_TABLE (self), (*event_id).id, "name", &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp2_ = sqlite3_column_text (stmt, 0);
	_tmp3_ = g_strdup (_tmp2_);
	name = _tmp3_;
	if (name != NULL) {
		gint _tmp6_;
		_tmp6_ = strlen (name);
		_tmp5_ = _tmp6_ > 0;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = name;
	} else {
		_tmp4_ = NULL;
	}
	_tmp7_ = g_strdup (_tmp4_);
	result = _tmp7_;
	_g_free0 (name);
	_sqlite3_finalize0 (stmt);
	return result;
}


gchar* event_table_get_primary_source_id (EventTable* self, EventID* event_id) {
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), NULL);
	_tmp1_ = database_table_select_by_id (DATABASE_TABLE (self), (*event_id).id, "primary_source_id", &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp2_ = sqlite3_column_text (stmt, 0);
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean event_table_set_primary_source_id (EventTable* self, EventID* event_id, const gchar* primary_source_id) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), FALSE);
	g_return_val_if_fail (primary_source_id != NULL, FALSE);
	_tmp0_ = database_table_update_text_by_id (DATABASE_TABLE (self), (*event_id).id, "primary_source_id", primary_source_id);
	result = _tmp0_;
	return result;
}


time_t event_table_get_time_created (EventTable* self, EventID* event_id) {
	time_t result = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gboolean _tmp1_;
	gint64 _tmp2_;
	g_return_val_if_fail (IS_EVENT_TABLE (self), 0);
	_tmp1_ = database_table_select_by_id (DATABASE_TABLE (self), (*event_id).id, "time_created", &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	if (!_tmp1_) {
		result = (time_t) 0;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp2_ = sqlite3_column_int64 (stmt, 0);
	result = (time_t) _tmp2_;
	_sqlite3_finalize0 (stmt);
	return result;
}


static void event_table_class_init (EventTableClass * klass) {
	event_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = event_table_finalize;
}


static void event_table_instance_init (EventTable * self) {
}


static void event_table_finalize (DatabaseTable* obj) {
	EventTable * self;
	self = EVENT_TABLE (obj);
	DATABASE_TABLE_CLASS (event_table_parent_class)->finalize (obj);
}


GType event_table_get_type (void) {
	static volatile gsize event_table_type_id__volatile = 0;
	if (g_once_init_enter (&event_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventTable), 0, (GInstanceInitFunc) event_table_instance_init, NULL };
		GType event_table_type_id;
		event_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "EventTable", &g_define_type_info, 0);
		g_once_init_leave (&event_table_type_id__volatile, event_table_type_id);
	}
	return event_table_type_id__volatile;
}



