/* VersionTable.c generated by valac 0.12.0, the Vala compiler
 * generated from VersionTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>


#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
typedef struct _VersionTablePrivate VersionTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VersionTable {
	DatabaseTable parent_instance;
	VersionTablePrivate * priv;
};

struct _VersionTableClass {
	DatabaseTableClass parent_class;
};


static gpointer version_table_parent_class = NULL;
static VersionTable* version_table_instance;
static VersionTable* version_table_instance = NULL;
extern sqlite3* database_table_db;

gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
enum  {
	VERSION_TABLE_DUMMY_PROPERTY
};
static VersionTable* version_table_new (void);
static VersionTable* version_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self, gchar** app_version);
void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data);
void version_table_update_version (VersionTable* self, gint version, const gchar* app_version);
static void version_table_finalize (DatabaseTable* obj);


static VersionTable* version_table_construct (GType object_type) {
	VersionTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	self = (VersionTable*) database_table_construct (object_type);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("create version table", res);
	}
	database_table_set_table_name (DATABASE_TABLE (self), "VersionTable");
	_sqlite3_finalize0 (stmt);
	return self;
}


static VersionTable* version_table_new (void) {
	return version_table_construct (TYPE_VERSION_TABLE);
}


static gpointer _database_table_ref0 (gpointer self) {
	return self ? database_table_ref (self) : NULL;
}


VersionTable* version_table_get_instance (void) {
	VersionTable* result = NULL;
	VersionTable* _tmp1_;
	if (version_table_instance == NULL) {
		VersionTable* _tmp0_ = NULL;
		_tmp0_ = version_table_new ();
		_database_table_unref0 (version_table_instance);
		version_table_instance = _tmp0_;
	}
	_tmp1_ = _database_table_ref0 (version_table_instance);
	result = _tmp1_;
	return result;
}


gint version_table_get_version (VersionTable* self, gchar** app_version) {
	gchar* _app_version = NULL;
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gint _tmp5_;
	g_return_val_if_fail (IS_VERSION_TABLE (self), 0);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT schema_version, app_version FROM VersionTable ORDER BY schema_v" \
"ersion DESC LIMIT 1", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_ROW) {
		if (res != SQLITE_DONE) {
			database_table_fatal ("get_version", res);
		}
		result = -1;
		_sqlite3_finalize0 (stmt);
		if (app_version) {
			*app_version = _app_version;
		} else {
			_g_free0 (_app_version);
		}
		return result;
	}
	_tmp3_ = sqlite3_column_text (stmt, 1);
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_app_version);
	_app_version = _tmp4_;
	_tmp5_ = sqlite3_column_int (stmt, 0);
	result = _tmp5_;
	_sqlite3_finalize0 (stmt);
	if (app_version) {
		*app_version = _app_version;
	} else {
		_g_free0 (_app_version);
	}
	return result;
}


void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data) {
	sqlite3_stmt* stmt = NULL;
	gchar* bitbucket = NULL;
	gchar* _tmp0_ = NULL;
	gint _tmp1_;
	gint _tmp6_;
	gint res;
	gchar* _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	g_return_if_fail (IS_VERSION_TABLE (self));
	g_return_if_fail (app_version != NULL);
	_tmp1_ = version_table_get_version (self, &_tmp0_);
	_g_free0 (bitbucket);
	bitbucket = _tmp0_;
	if (_tmp1_ != (-1)) {
		sqlite3_stmt* _tmp2_ = NULL;
		gint _tmp3_;
		gint res;
		_tmp3_ = sqlite3_prepare_v2 (database_table_db, "UPDATE VersionTable SET schema_version=?, app_version=?, user_data=?", -1, &_tmp2_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp2_;
		res = _tmp3_;
		g_assert (res == SQLITE_OK);
	} else {
		sqlite3_stmt* _tmp4_ = NULL;
		gint _tmp5_;
		gint res;
		_tmp5_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO VersionTable (schema_version, app_version, user_data) VALU" \
"ES (?,?, ?)", -1, &_tmp4_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp4_;
		res = _tmp5_;
		g_assert (res == SQLITE_OK);
	}
	_tmp6_ = sqlite3_bind_int (stmt, 1, version);
	res = _tmp6_;
	g_assert (res == SQLITE_OK);
	_tmp7_ = g_strdup (app_version);
	_tmp8_ = sqlite3_bind_text (stmt, 2, _tmp7_, -1, g_free);
	res = _tmp8_;
	g_assert (res == SQLITE_OK);
	_tmp9_ = g_strdup (user_data);
	_tmp10_ = sqlite3_bind_text (stmt, 3, _tmp9_, -1, g_free);
	res = _tmp10_;
	g_assert (res == SQLITE_OK);
	_tmp11_ = sqlite3_step (stmt);
	res = _tmp11_;
	if (res != SQLITE_DONE) {
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		_tmp12_ = g_strdup_printf ("set_version %d %s %s", version, app_version, user_data);
		_tmp13_ = _tmp12_;
		database_table_fatal (_tmp13_, res);
		_g_free0 (_tmp13_);
	}
	_g_free0 (bitbucket);
	_sqlite3_finalize0 (stmt);
}


void version_table_update_version (VersionTable* self, gint version, const gchar* app_version) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (IS_VERSION_TABLE (self));
	g_return_if_fail (app_version != NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "UPDATE VersionTable SET schema_version=?, app_version=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int (stmt, 1, version);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = g_strdup (app_version);
	_tmp4_ = sqlite3_bind_text (stmt, 2, _tmp3_, -1, g_free);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt);
	res = _tmp5_;
	if (res != SQLITE_DONE) {
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		_tmp6_ = g_strdup_printf ("update_version %d", version);
		_tmp7_ = _tmp6_;
		database_table_fatal (_tmp7_, res);
		_g_free0 (_tmp7_);
	}
	_sqlite3_finalize0 (stmt);
}


static void version_table_class_init (VersionTableClass * klass) {
	version_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = version_table_finalize;
}


static void version_table_instance_init (VersionTable * self) {
}


static void version_table_finalize (DatabaseTable* obj) {
	VersionTable * self;
	self = VERSION_TABLE (obj);
	DATABASE_TABLE_CLASS (version_table_parent_class)->finalize (obj);
}


GType version_table_get_type (void) {
	static volatile gsize version_table_type_id__volatile = 0;
	if (g_once_init_enter (&version_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VersionTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) version_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VersionTable), 0, (GInstanceInitFunc) version_table_instance_init, NULL };
		GType version_table_type_id;
		version_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VersionTable", &g_define_type_info, 0);
		g_once_init_leave (&version_table_type_id__volatile, version_table_type_id);
	}
	return version_table_type_id__volatile;
}



