/* LibraryMonitor.c generated by valac 0.12.0, the Vala compiler
 * generated from LibraryMonitor.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* LibraryMonitor uses DirectoryMonitor to track assets in the user's library directory and make*/
/* sure they're reflected in the application.*/
/**/
/* NOTE: There appears to be a bug where prior versions of Shotwell (<= 0.6.x) were not*/
/* properly loading the file modification timestamp during import.  This was no issue*/
/* before but becomes imperative now with file monitoring.  A "proper" algorithm is*/
/* to reimport an entire photo if the modification time in the database is different*/
/* than the file's, but that's Real Bad when the user first turns on monitoring, as it*/
/* will cause a lot of reimports (think of a 10,000 photo database) and will blow away*/
/* ALL transformations, as they are now suspect.*/
/**/
/* So: If the modification time is zero and filesize is the same, simply update the*/
/* timestamp in the database and move on.*/
/**/
/* TODO: Although it seems highly unlikely that a file's timestamp could change but the file size*/
/* has not and the file really be "changed", it *is* possible, even in the case of complex little*/
/* animals like photo files.  We could be more liberal and treat this case as a metadata-changed*/
/* situation (since that's a likely case).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>
#include <gobject/gvaluecollector.h>


#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;
typedef struct _LibraryMonitorPoolPrivate LibraryMonitorPoolPrivate;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
typedef struct _ParamSpecLibraryMonitorPool ParamSpecLibraryMonitorPool;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;
typedef struct _LibraryMonitorPrivate LibraryMonitorPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_BATCH_IMPORT (batch_import_get_type ())
#define BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT, BatchImport))
#define BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT, BatchImportClass))
#define IS_BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT))
#define IS_BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT))
#define BATCH_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT, BatchImportClass))

typedef struct _BatchImport BatchImport;
typedef struct _BatchImportClass BatchImportClass;

#define TYPE_BATCH_IMPORT_ROLL (batch_import_roll_get_type ())
#define BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRoll))
#define BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))
#define IS_BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_ROLL))
#define IS_BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_ROLL))
#define BATCH_IMPORT_ROLL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))

typedef struct _BatchImportRoll BatchImportRoll;
typedef struct _BatchImportRollClass BatchImportRollClass;

#define LIBRARY_MONITOR_TYPE_VERIFY_JOB (library_monitor_verify_job_get_type ())
#define LIBRARY_MONITOR_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJob))
#define LIBRARY_MONITOR_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))
#define LIBRARY_MONITOR_IS_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_IS_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))

typedef struct _LibraryMonitorVerifyJob LibraryMonitorVerifyJob;
typedef struct _LibraryMonitorVerifyJobClass LibraryMonitorVerifyJobClass;

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _batch_import_roll_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_roll_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_MEDIA_COLLECTION_REGISTRY (media_collection_registry_get_type ())
#define MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry))
#define MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))
#define IS_MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_COLLECTION_REGISTRY))
#define IS_MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_COLLECTION_REGISTRY))
#define MEDIA_COLLECTION_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))

typedef struct _MediaCollectionRegistry MediaCollectionRegistry;
typedef struct _MediaCollectionRegistryClass MediaCollectionRegistryClass;
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))

#define MEDIA_MONITOR_TYPE_DISCOVERED_FILE (media_monitor_discovered_file_get_type ())

#define TYPE_TOMBSTONE_SOURCE_COLLECTION (tombstone_source_collection_get_type ())
#define TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollection))
#define TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))
#define IS_TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define IS_TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define TOMBSTONE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))

typedef struct _TombstoneSourceCollection TombstoneSourceCollection;
typedef struct _TombstoneSourceCollectionClass TombstoneSourceCollectionClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB (library_monitor_find_move_job_get_type ())
#define LIBRARY_MONITOR_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))

typedef struct _LibraryMonitorFindMoveJob LibraryMonitorFindMoveJob;
typedef struct _LibraryMonitorFindMoveJobClass LibraryMonitorFindMoveJobClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _LibraryMonitorAsyncDiscoveryCompletedData LibraryMonitorAsyncDiscoveryCompletedData;
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _LibraryMonitorFindMoveJobPrivate LibraryMonitorFindMoveJobPrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _library_monitor_verify_job_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_verify_job_unref (var), NULL)))
typedef struct _LibraryMonitorVerifyJobPrivate LibraryMonitorVerifyJobPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LibraryMonitorVerifyMonitorableData LibraryMonitorVerifyMonitorableData;

#define TYPE_BATCH_IMPORT_JOB (batch_import_job_get_type ())
#define BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJob))
#define BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))
#define IS_BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_JOB))
#define IS_BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_JOB))
#define BATCH_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))

typedef struct _BatchImportJob BatchImportJob;
typedef struct _BatchImportJobClass BatchImportJobClass;

#define TYPE_FILE_IMPORT_JOB (file_import_job_get_type ())
#define FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_IMPORT_JOB, FileImportJob))
#define FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_IMPORT_JOB, FileImportJobClass))
#define IS_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_IMPORT_JOB))
#define IS_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_IMPORT_JOB))
#define FILE_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_IMPORT_JOB, FileImportJobClass))

typedef struct _FileImportJob FileImportJob;
typedef struct _FileImportJobClass FileImportJobClass;
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))

#define TYPE_IMPORT_MANIFEST (import_manifest_get_type ())
#define IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_MANIFEST, ImportManifest))
#define IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_MANIFEST, ImportManifestClass))
#define IS_IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_MANIFEST))
#define IS_IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_MANIFEST))
#define IMPORT_MANIFEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_MANIFEST, ImportManifestClass))

typedef struct _ImportManifest ImportManifest;
typedef struct _ImportManifestClass ImportManifestClass;
typedef struct _ImportManifestPrivate ImportManifestPrivate;

#define TYPE_BATCH_IMPORT_RESULT (batch_import_result_get_type ())
#define BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResult))
#define BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))
#define IS_BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_RESULT))
#define IS_BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_RESULT))
#define BATCH_IMPORT_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))

typedef struct _BatchImportResult BatchImportResult;
typedef struct _BatchImportResultClass BatchImportResultClass;
typedef struct _BatchImportResultPrivate BatchImportResultPrivate;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _batch_import_result_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_result_unref (var), NULL)))

#define TYPE_TOMBSTONED_FILE (tombstoned_file_get_type ())
#define TOMBSTONED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONED_FILE, TombstonedFile))
#define TOMBSTONED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONED_FILE, TombstonedFileClass))
#define IS_TOMBSTONED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONED_FILE))
#define IS_TOMBSTONED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONED_FILE))
#define TOMBSTONED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONED_FILE, TombstonedFileClass))

typedef struct _TombstonedFile TombstonedFile;
typedef struct _TombstonedFileClass TombstonedFileClass;
#define _tombstoned_file_unref0(var) ((var == NULL) ? NULL : (var = (tombstoned_file_unref (var), NULL)))

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())

#define LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB (library_monitor_runtime_find_move_job_get_type ())
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))

typedef struct _LibraryMonitorRuntimeFindMoveJob LibraryMonitorRuntimeFindMoveJob;
typedef struct _LibraryMonitorRuntimeFindMoveJobClass LibraryMonitorRuntimeFindMoveJobClass;
typedef struct _LibraryMonitorRuntimeFindMoveJobPrivate LibraryMonitorRuntimeFindMoveJobPrivate;

#define TYPE_TOMBSTONE (tombstone_get_type ())
#define TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE, Tombstone))
#define TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE, TombstoneClass))
#define IS_TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE))
#define IS_TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE))
#define TOMBSTONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE, TombstoneClass))

typedef struct _Tombstone Tombstone;
typedef struct _TombstoneClass TombstoneClass;

#define TYPE_ABSTRACT_SEMAPHORE (abstract_semaphore_get_type ())
#define ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore))
#define ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))
#define IS_ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_SEMAPHORE))
#define IS_ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_SEMAPHORE))
#define ABSTRACT_SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))

typedef struct _AbstractSemaphore AbstractSemaphore;
typedef struct _AbstractSemaphoreClass AbstractSemaphoreClass;
typedef struct _LibraryMonitorParamSpecVerifyJob LibraryMonitorParamSpecVerifyJob;

struct _LibraryMonitorPool {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorPoolPrivate * priv;
};

struct _LibraryMonitorPoolClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorPool *self);
};

struct _LibraryMonitorPoolPrivate {
	LibraryMonitor* monitor;
	guint timer_id;
};

struct _ParamSpecLibraryMonitorPool {
	GParamSpec parent_instance;
};

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _LibraryMonitor {
	DirectoryMonitor parent_instance;
	LibraryMonitorPrivate * priv;
};

struct _LibraryMonitorClass {
	DirectoryMonitorClass parent_class;
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryMonitorPrivate {
	Workers* workers;
	GCancellable* cancellable;
	gboolean auto_import;
	GeeHashSet* unknown_files;
	GeeList* monitors;
	GeeHashMap* discovered;
	GeeHashSet* import_queue;
	GeeHashSet* pending_imports;
	GeeArrayList* batch_import_queue;
	BatchImportRoll* current_import_roll;
	time_t last_import_roll_use;
	BatchImport* current_batch_import;
	gint checksums_completed;
	gint checksums_total;
	guint import_queue_timer_id;
	GeeQueue* verify_queue;
	gint outstanding_verify_jobs;
	gint completed_monitorable_verifies;
	gint total_monitorable_verifies;
};

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
typedef enum  {
	MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED,
	MEDIA_MONITOR_DISCOVERED_FILE_IGNORE,
	MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN
} MediaMonitorDiscoveredFile;

struct _LibraryMonitorAsyncDiscoveryCompletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	LibraryMonitor* self;
	gint _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* all_candidates;
	GeeArrayList* _tmp2_;
	GeeArrayList* adopted;
	GeeIterator* _tmp3_;
	GeeIterator* _file_it;
	gboolean _tmp4_;
	gpointer _tmp5_;
	GFile* file;
	GFileInfo* _tmp6_;
	GFileInfo* info;
	GeeCollection* candidates;
	gboolean associated;
	GeeList* _tmp7_;
	GeeList* _monitor_list;
	gint _tmp8_;
	gint _monitor_size;
	gint _monitor_index;
	gpointer _tmp9_;
	MediaMonitor* monitor;
	MediaMonitorDiscoveredFile _result_;
	MediaMonitorDiscoveredFile _tmp10_;
	GeeCollection* _tmp11_;
	gboolean _tmp12_;
	gint _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* job_candidates;
	GeeArrayList* _tmp15_;
	LibraryMonitorFindMoveJob* _tmp16_;
	LibraryMonitorFindMoveJob* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
};

typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _LibraryMonitorFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GeeArrayList* losers;
	GError* err;
};

struct _LibraryMonitorFindMoveJobClass {
	BackgroundJobClass parent_class;
};

struct _LibraryMonitorVerifyJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorVerifyJobPrivate * priv;
	Monitorable* monitorable;
	MediaMonitor* monitor;
};

struct _LibraryMonitorVerifyJobClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorVerifyJob *self);
};

struct _LibraryMonitorVerifyMonitorableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	LibraryMonitor* self;
	Monitorable* monitorable;
	MediaMonitor* monitor;
	GFile** _tmp0_;
	GFile** files;
	gint files_length1;
	gint _files_size_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gint _tmp3_;
	GFile** _tmp4_;
	GFile** aux_files;
	gint aux_files_length1;
	gint _aux_files_size_;
	GFile** aux_file_collection;
	int aux_file_collection_length1;
	int aux_file_it;
	GFile* _tmp5_;
	GFile* aux_file;
	GFile* _tmp6_;
	gint ctr;
	gboolean _tmp7_;
	GFile* _tmp8_;
	GFile* file;
	GFileInfo* _tmp9_;
	GFileInfo* info;
	GFileInfo* _tmp10_;
	GFileInfo* _tmp11_;
	GError * err;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GError * _inner_error_;
};

typedef void (*BatchImportImportReporter) (ImportManifest* manifest, BatchImportRoll* import_roll, void* user_data);
struct _ImportManifest {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImportManifestPrivate * priv;
	GeeList* imported;
	GeeList* success;
	GeeList* camera_failed;
	GeeList* failed;
	GeeList* write_failed;
	GeeList* skipped_photos;
	GeeList* skipped_files;
	GeeList* aborted;
	GeeList* already_imported;
	GeeList* all;
};

struct _ImportManifestClass {
	GTypeClass parent_class;
	void (*finalize) (ImportManifest *self);
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR
} ImportResult;

struct _BatchImportResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportResultPrivate * priv;
	BatchImportJob* job;
	GFile* file;
	gchar* src_identifier;
	gchar* dest_identifier;
	ImportResult result;
	gchar* errmsg;
};

struct _BatchImportResultClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportResult *self);
};

typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _LibraryMonitorRuntimeFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorRuntimeFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GError* err;
};

struct _LibraryMonitorRuntimeFindMoveJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
struct _LibraryMonitorParamSpecVerifyJob {
	GParamSpec parent_instance;
};


static gpointer library_monitor_pool_parent_class = NULL;
static LibraryMonitorPool* library_monitor_pool_instance;
static LibraryMonitorPool* library_monitor_pool_instance = NULL;
static gpointer library_monitor_parent_class = NULL;
static GeeHashSet* library_monitor_blacklist;
static GStaticRecMutex __lock_library_monitor_blacklist = {0};
static GeeHashSet* library_monitor_blacklist = NULL;
static HashTimedQueue* library_monitor_to_unblacklist;
static HashTimedQueue* library_monitor_to_unblacklist = NULL;
extern TombstoneSourceCollection* tombstone_global;
extern gboolean commandline_options_no_runtime_monitoring;
static gpointer library_monitor_find_move_job_parent_class = NULL;
static gpointer library_monitor_runtime_find_move_job_parent_class = NULL;
static gpointer library_monitor_verify_job_parent_class = NULL;

gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_library_monitor_pool (GValue* value, gpointer v_object);
void value_take_library_monitor_pool (GValue* value, gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
#define LIBRARY_MONITOR_POOL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolPrivate))
enum  {
	LIBRARY_MONITOR_POOL_DUMMY_PROPERTY
};
static LibraryMonitorPool* library_monitor_pool_new (void);
static LibraryMonitorPool* library_monitor_pool_construct (GType object_type);
void library_monitor_pool_init (void);
void library_monitor_pool_terminate (void);
static void library_monitor_pool_close (LibraryMonitorPool* self);
LibraryMonitorPool* library_monitor_pool_get_instance (void);
LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self);
void library_monitor_pool_replace (LibraryMonitorPool* self, LibraryMonitor* replacement, gint start_msec_delay);
static gboolean library_monitor_pool_on_start_monitor (LibraryMonitorPool* self);
static gboolean _library_monitor_pool_on_start_monitor_gsource_func (gpointer self);
void directory_monitor_close (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self);
static void library_monitor_pool_finalize (LibraryMonitorPool* obj);
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
GType batch_import_get_type (void) G_GNUC_CONST;
gpointer batch_import_roll_ref (gpointer instance);
void batch_import_roll_unref (gpointer instance);
GParamSpec* param_spec_batch_import_roll (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_roll (GValue* value, gpointer v_object);
void value_take_batch_import_roll (GValue* value, gpointer v_object);
gpointer value_get_batch_import_roll (const GValue* value);
GType batch_import_roll_get_type (void) G_GNUC_CONST;
static gpointer library_monitor_verify_job_ref (gpointer instance);
static void library_monitor_verify_job_unref (gpointer instance);
static GParamSpec* library_monitor_param_spec_verify_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void library_monitor_value_set_verify_job (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void library_monitor_value_take_verify_job (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer library_monitor_value_get_verify_job (const GValue* value) G_GNUC_UNUSED;
static GType library_monitor_verify_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define LIBRARY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_MONITOR, LibraryMonitorPrivate))
enum  {
	LIBRARY_MONITOR_DUMMY_PROPERTY
};
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
static void library_monitor_on_config_changed (LibraryMonitor* self);
static void _library_monitor_on_config_changed_configuration_facade_auto_import_from_library_changed (ConfigurationFacade* _sender, gpointer self);
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_timed_queue (GValue* value, gpointer v_object);
void value_take_timed_queue (GValue* value, gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
#define LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC (5 * 1000)
static void library_monitor_on_unblacklist_file (GFile* file);
static void _library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item, gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
gint workers_thread_per_cpu_minus_one (void);
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
#define LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC 3
#define LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC (5 * 60)
#define LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS 5
LibraryMonitor* library_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
LibraryMonitor* library_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
gboolean configuration_facade_get_auto_import_from_library (ConfigurationFacade* self);
static gboolean library_monitor_on_flush_import_queue (LibraryMonitor* self);
static gboolean _library_monitor_on_flush_import_queue_gsource_func (gpointer self);
static void library_monitor_real_close (DirectoryMonitor* base);
void media_monitor_close (MediaMonitor* self);
static void library_monitor_add_to_discovered_list (LibraryMonitor* self, MediaMonitor* monitor, Monitorable* monitorable);
static MediaMonitor* library_monitor_get_monitor_for_monitorable (LibraryMonitor* self, Monitorable* monitorable);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
MediaSourceCollection* media_monitor_get_media_source_collection (MediaMonitor* self);
gboolean source_collection_holds_type_of_source (SourceCollection* self, DataSource* source);
gchar* data_object_to_string (DataObject* self);
static void library_monitor_real_discovery_started (DirectoryMonitor* base);
gpointer media_collection_registry_ref (gpointer instance);
void media_collection_registry_unref (gpointer instance);
GParamSpec* param_spec_media_collection_registry (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_collection_registry (GValue* value, gpointer v_object);
void value_take_media_collection_registry (GValue* value, gpointer v_object);
gpointer value_get_media_collection_registry (const GValue* value);
GType media_collection_registry_get_type (void) G_GNUC_CONST;
MediaCollectionRegistry* media_collection_registry_get_instance (void);
GeeCollection* media_collection_registry_get_all (MediaCollectionRegistry* self);
MediaMonitor* media_source_collection_create_media_monitor (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
void media_monitor_notify_discovery_started (MediaMonitor* self);
static void library_monitor_real_file_discovered (DirectoryMonitor* base, GFile* file, GFileInfo* info);
GType media_monitor_discovered_file_get_type (void) G_GNUC_CONST;
MediaMonitorDiscoveredFile media_monitor_notify_file_discovered (MediaMonitor* self, GFile* file, GFileInfo* info, Monitorable** monitorable);
GType tombstone_source_collection_get_type (void) G_GNUC_CONST;
gboolean tombstone_source_collection_matches (TombstoneSourceCollection* self, GFile* file);
static gboolean library_monitor_is_supported_filetype (LibraryMonitor* self, GFile* file);
static void library_monitor_real_discovery_completed (DirectoryMonitor* base);
static void library_monitor_async_discovery_completed (LibraryMonitor* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void library_monitor_async_discovery_completed_finish (LibraryMonitor* self, GAsyncResult* _res_);
static void library_monitor_async_discovery_completed_data_free (gpointer _data);
static gboolean library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* data);
static void library_monitor_discovery_stage_completed (LibraryMonitor* self);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
GeeCollection* media_monitor_candidates_for_unknown_file (MediaMonitor* self, GFile* file, GFileInfo* info, MediaMonitorDiscoveredFile* _result_);
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
void value_take_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
void workers_enqueue (Workers* self, BackgroundJob* job);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static GType library_monitor_find_move_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean _library_monitor_async_discovery_completed_co_gsource_func (gpointer self);
void directory_monitor_mdbg (const gchar* msg);
static void library_monitor_report_checksum_job_completed (LibraryMonitor* self);
static void library_monitor_on_find_move_completed (LibraryMonitor* self, BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
void media_monitor_update_master_file (MediaMonitor* self, Monitorable* monitorable, GFile* file);
static void library_monitor_on_find_move_cancelled (LibraryMonitor* self, BackgroundJob* j);
static void library_monitor_enqueue_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor);
GeeCollection* data_collection_get_all (DataCollection* self);
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
static void library_monitor_enqueue_import_many (LibraryMonitor* self, GeeCollection* files);
void tombstone_source_collection_launch_scan (TombstoneSourceCollection* self, DirectoryMonitor* monitor, GCancellable* cancellable);
static LibraryMonitorVerifyJob* library_monitor_verify_job_new (Monitorable* monitorable, MediaMonitor* monitor);
static LibraryMonitorVerifyJob* library_monitor_verify_job_construct (GType object_type, Monitorable* monitorable, MediaMonitor* monitor);
static void library_monitor_execute_next_verify_job (LibraryMonitor* self);
static void library_monitor_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void library_monitor_verify_monitorable_finish (LibraryMonitor* self, GAsyncResult* _res_);
static void library_monitor_verify_monitorable_data_free (gpointer _data);
static gboolean library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* data);
GFile* media_monitor_get_master_file (MediaMonitor* self, Monitorable* monitorable);
GFile** media_monitor_get_auxilliary_backing_files (MediaMonitor* self, Monitorable* monitorable, int* result_length1);
static void _vala_array_add278 (GFile*** array, int* length, int* size, GFile* value);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
static void library_monitor_verify_monitorable_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
gboolean media_monitor_is_offline (MediaMonitor* self, Monitorable* monitorable);
void media_monitor_update_online (MediaMonitor* self, Monitorable* monitorable);
void media_monitor_update_offline (MediaMonitor* self, Monitorable* monitorable);
void media_monitor_update_backing_file_info (MediaMonitor* self, Monitorable* monitorable, GFile* file, GFileInfo* info);
static gboolean _library_monitor_verify_monitorable_co_gsource_func (gpointer self);
static void library_monitor_import_unrepresented_files (LibraryMonitor* self);
static void library_monitor_cancel_batch_imports (LibraryMonitor* self);
static void library_monitor_enqueue_import (LibraryMonitor* self, GFile* file);
gboolean library_monitor_is_blacklisted (GFile* file);
static void library_monitor_remove_queued_import (LibraryMonitor* self, GFile* file);
gulong now_sec (void);
BatchImportRoll* batch_import_roll_new (void);
BatchImportRoll* batch_import_roll_construct (GType object_type);
gpointer batch_import_job_ref (gpointer instance);
void batch_import_job_unref (gpointer instance);
GParamSpec* param_spec_batch_import_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_job (GValue* value, gpointer v_object);
void value_take_batch_import_job (GValue* value, gpointer v_object);
gpointer value_get_batch_import_job (const GValue* value);
GType batch_import_job_get_type (void) G_GNUC_CONST;
FileImportJob* file_import_job_new (GFile* file_or_dir, gboolean copy_to_library);
FileImportJob* file_import_job_construct (GType object_type, GFile* file_or_dir, gboolean copy_to_library);
GType file_import_job_get_type (void) G_GNUC_CONST;
gpointer import_manifest_ref (gpointer instance);
void import_manifest_unref (gpointer instance);
GParamSpec* param_spec_import_manifest (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_import_manifest (GValue* value, gpointer v_object);
void value_take_import_manifest (GValue* value, gpointer v_object);
gpointer value_get_import_manifest (const GValue* value);
GType import_manifest_get_type (void) G_GNUC_CONST;
BatchImport* batch_import_new (GeeIterable* jobs, const gchar* name, BatchImportImportReporter reporter, void* reporter_target, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable, BatchImportRoll* import_roll, ImportManifest* skip_manifest);
BatchImport* batch_import_construct (GType object_type, GeeIterable* jobs, const gchar* name, BatchImportImportReporter reporter, void* reporter_target, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable, BatchImportRoll* import_roll, ImportManifest* skip_manifest);
void batch_import_set_untrash_duplicates (BatchImport* self, gboolean untrash_duplicates);
void batch_import_set_mark_duplicates_online (BatchImport* self, gboolean mark_duplicates_online);
static void library_monitor_schedule_next_batch_import (LibraryMonitor* self);
static void library_monitor_on_import_preparing (LibraryMonitor* self);
static void _library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender, gpointer self);
static void library_monitor_on_import_progress (LibraryMonitor* self, guint64 completed_bytes, guint64 total_bytes);
static void _library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender, guint64 completed_bytes, guint64 total_bytes, gpointer self);
static void library_monitor_on_import_complete (LibraryMonitor* self, BatchImport* batch_import, ImportManifest* manifest, BatchImportRoll* import_roll);
static void _library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender, ImportManifest* manifest, BatchImportRoll* import_roll, gpointer self);
void batch_import_schedule (BatchImport* self);
static void library_monitor_discard_current_batch_import (LibraryMonitor* self);
void batch_import_user_halt (BatchImport* self);
gpointer batch_import_result_ref (gpointer instance);
void batch_import_result_unref (gpointer instance);
GParamSpec* param_spec_batch_import_result (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_result (GValue* value, gpointer v_object);
void value_take_batch_import_result (GValue* value, gpointer v_object);
gpointer value_get_batch_import_result (const GValue* value);
GType batch_import_result_get_type (void) G_GNUC_CONST;
GType import_result_get_type (void) G_GNUC_CONST;
gpointer tombstoned_file_ref (gpointer instance);
void tombstoned_file_unref (gpointer instance);
GParamSpec* param_spec_tombstoned_file (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_tombstoned_file (GValue* value, gpointer v_object);
void value_take_tombstoned_file (GValue* value, gpointer v_object);
gpointer value_get_tombstoned_file (const GValue* value);
GType tombstoned_file_get_type (void) G_GNUC_CONST;
TombstonedFile* tombstoned_file_new (GFile* file, gint64 filesize, const gchar* md5);
TombstonedFile* tombstoned_file_construct (GType object_type, GFile* file, gint64 filesize, const gchar* md5);
GType tombstone_reason_get_type (void) G_GNUC_CONST;
GQuark database_error_quark (void);
void tombstone_entomb_many_files (GeeCollection* files, TombstoneReason reason, GError** error);
void app_window_database_error (GError* err);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
gboolean timed_queue_contains (TimedQueue* self, gconstpointer item);
gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item);
MediaSourceCollection* media_collection_registry_get_collection_for_file (MediaCollectionRegistry* self, GFile* file);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
gboolean media_monitor_is_file_represented (MediaMonitor* self, GFile* file);
static void library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self, GFile* file);
static void library_monitor_real_notify_file_created (DirectoryMonitor* base, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
gboolean media_monitor_notify_file_created (MediaMonitor* self, GFile* file, GFileInfo* info);
gchar* media_monitor_to_string (MediaMonitor* self);
const gchar* media_monitor_discovered_file_to_string (MediaMonitorDiscoveredFile self);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static GType library_monitor_runtime_find_move_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void library_monitor_on_runtime_find_move_completed (LibraryMonitor* self, BackgroundJob* j);
static void library_monitor_real_notify_file_moved (DirectoryMonitor* base, GFile* old_file, GFile* new_file, GFileInfo* new_info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
gboolean media_monitor_notify_file_moved (MediaMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void library_monitor_real_notify_file_altered (DirectoryMonitor* base, GFile* file);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
gboolean media_monitor_notify_file_altered (MediaMonitor* self, GFile* file);
static void library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base, GFile* file);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
gboolean media_monitor_notify_file_attributes_altered (MediaMonitor* self, GFile* file);
static void library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
gboolean media_monitor_notify_file_alteration_completed (MediaMonitor* self, GFile* file, GFileInfo* info);
static void library_monitor_real_notify_file_deleted (DirectoryMonitor* base, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
gboolean media_monitor_notify_file_deleted (MediaMonitor* self, GFile* file);
GType tombstone_get_type (void) G_GNUC_CONST;
Tombstone* tombstone_source_collection_locate (TombstoneSourceCollection* self, GFile* file);
void tombstone_source_collection_resurrect (TombstoneSourceCollection* self, Tombstone* tombstone);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
enum  {
	LIBRARY_MONITOR_FIND_MOVE_JOB_DUMMY_PROPERTY
};
static void _library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job, gpointer self);
static void _library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
gpointer abstract_semaphore_ref (gpointer instance);
void abstract_semaphore_unref (gpointer instance);
GParamSpec* param_spec_abstract_semaphore (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_abstract_semaphore (GValue* value, gpointer v_object);
void value_take_abstract_semaphore (GValue* value, gpointer v_object);
gpointer value_get_abstract_semaphore (const GValue* value);
GType abstract_semaphore_get_type (void) G_GNUC_CONST;
BackgroundJob* background_job_construct (GType object_type, GObject* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target, AbstractSemaphore* completion_semaphore);
void background_job_set_completion_priority (BackgroundJob* self, gint priority);
static void library_monitor_find_move_job_real_execute (BackgroundJob* base);
GFile* media_source_get_master_file (MediaSource* self);
gchar* md5_file (GFile* file, GError** error);
gchar* media_source_get_master_md5 (MediaSource* self);
static void library_monitor_find_move_job_finalize (BackgroundJob* obj);
enum  {
	LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_DUMMY_PROPERTY
};
static void _library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job, gpointer self);
static void library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base);
static void library_monitor_runtime_find_move_job_finalize (BackgroundJob* obj);
enum  {
	LIBRARY_MONITOR_VERIFY_JOB_DUMMY_PROPERTY
};
static void library_monitor_verify_job_finalize (LibraryMonitorVerifyJob* obj);
static void library_monitor_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static LibraryMonitorPool* library_monitor_pool_construct (GType object_type) {
	LibraryMonitorPool* self = NULL;
	self = (LibraryMonitorPool*) g_type_create_instance (object_type);
	return self;
}


static LibraryMonitorPool* library_monitor_pool_new (void) {
	return library_monitor_pool_construct (TYPE_LIBRARY_MONITOR_POOL);
}


void library_monitor_pool_init (void) {
}


void library_monitor_pool_terminate (void) {
	if (library_monitor_pool_instance != NULL) {
		library_monitor_pool_close (library_monitor_pool_instance);
	}
	_library_monitor_pool_unref0 (library_monitor_pool_instance);
	library_monitor_pool_instance = NULL;
}


static gpointer _library_monitor_pool_ref0 (gpointer self) {
	return self ? library_monitor_pool_ref (self) : NULL;
}


LibraryMonitorPool* library_monitor_pool_get_instance (void) {
	LibraryMonitorPool* result = NULL;
	LibraryMonitorPool* _tmp1_;
	if (library_monitor_pool_instance == NULL) {
		LibraryMonitorPool* _tmp0_ = NULL;
		_tmp0_ = library_monitor_pool_new ();
		_library_monitor_pool_unref0 (library_monitor_pool_instance);
		library_monitor_pool_instance = _tmp0_;
	}
	_tmp1_ = _library_monitor_pool_ref0 (library_monitor_pool_instance);
	result = _tmp1_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self) {
	LibraryMonitor* result = NULL;
	LibraryMonitor* _tmp0_;
	g_return_val_if_fail (IS_LIBRARY_MONITOR_POOL (self), NULL);
	_tmp0_ = _g_object_ref0 (self->priv->monitor);
	result = _tmp0_;
	return result;
}


static gboolean _library_monitor_pool_on_start_monitor_gsource_func (gpointer self) {
	gboolean result;
	result = library_monitor_pool_on_start_monitor (self);
	return result;
}


void library_monitor_pool_replace (LibraryMonitorPool* self, LibraryMonitor* replacement, gint start_msec_delay) {
	LibraryMonitor* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (IS_LIBRARY_MONITOR_POOL (self));
	g_return_if_fail (IS_LIBRARY_MONITOR (replacement));
	library_monitor_pool_close (self);
	_tmp0_ = _g_object_ref0 (replacement);
	_g_object_unref0 (self->priv->monitor);
	self->priv->monitor = _tmp0_;
	if (start_msec_delay > 0) {
		_tmp1_ = self->priv->timer_id == 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		guint _tmp2_;
		_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) start_msec_delay, _library_monitor_pool_on_start_monitor_gsource_func, library_monitor_pool_ref (self), library_monitor_pool_unref);
		self->priv->timer_id = _tmp2_;
	}
	g_signal_emit_by_name (self, "monitor-installed", self->priv->monitor);
}


static void library_monitor_pool_close (LibraryMonitorPool* self) {
	LibraryMonitor* _tmp0_;
	LibraryMonitor* closed;
	g_return_if_fail (IS_LIBRARY_MONITOR_POOL (self));
	if (self->priv->monitor == NULL) {
		return;
	}
	directory_monitor_close (DIRECTORY_MONITOR (self->priv->monitor));
	_tmp0_ = _g_object_ref0 (self->priv->monitor);
	closed = _tmp0_;
	_g_object_unref0 (self->priv->monitor);
	self->priv->monitor = NULL;
	g_signal_emit_by_name (self, "monitor-destroyed", closed);
	_g_object_unref0 (closed);
}


static gboolean library_monitor_pool_on_start_monitor (LibraryMonitorPool* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_LIBRARY_MONITOR_POOL (self), FALSE);
	self->priv->timer_id = (guint) 0;
	if (self->priv->monitor == NULL) {
		result = FALSE;
		return result;
	}
	directory_monitor_start_discovery (DIRECTORY_MONITOR (self->priv->monitor));
	result = FALSE;
	return result;
}


static void value_library_monitor_pool_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_library_monitor_pool_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		library_monitor_pool_unref (value->data[0].v_pointer);
	}
}


static void value_library_monitor_pool_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = library_monitor_pool_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_library_monitor_pool_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_library_monitor_pool_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		LibraryMonitorPool* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = library_monitor_pool_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_library_monitor_pool_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	LibraryMonitorPool** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = library_monitor_pool_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecLibraryMonitorPool* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LIBRARY_MONITOR_POOL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_library_monitor_pool (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL), NULL);
	return value->data[0].v_pointer;
}


void value_set_library_monitor_pool (GValue* value, gpointer v_object) {
	LibraryMonitorPool* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		library_monitor_pool_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_pool_unref (old);
	}
}


void value_take_library_monitor_pool (GValue* value, gpointer v_object) {
	LibraryMonitorPool* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_pool_unref (old);
	}
}


static void library_monitor_pool_class_init (LibraryMonitorPoolClass * klass) {
	library_monitor_pool_parent_class = g_type_class_peek_parent (klass);
	LIBRARY_MONITOR_POOL_CLASS (klass)->finalize = library_monitor_pool_finalize;
	g_type_class_add_private (klass, sizeof (LibraryMonitorPoolPrivate));
	g_signal_new ("monitor_installed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
	g_signal_new ("monitor_destroyed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
}


static void library_monitor_pool_instance_init (LibraryMonitorPool * self) {
	self->priv = LIBRARY_MONITOR_POOL_GET_PRIVATE (self);
	self->priv->monitor = NULL;
	self->priv->timer_id = (guint) 0;
	self->ref_count = 1;
}


static void library_monitor_pool_finalize (LibraryMonitorPool* obj) {
	LibraryMonitorPool * self;
	self = LIBRARY_MONITOR_POOL (obj);
	_g_object_unref0 (self->priv->monitor);
}


GType library_monitor_pool_get_type (void) {
	static volatile gsize library_monitor_pool_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_pool_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_library_monitor_pool_init, value_library_monitor_pool_free_value, value_library_monitor_pool_copy_value, value_library_monitor_pool_peek_pointer, "p", value_library_monitor_pool_collect_value, "p", value_library_monitor_pool_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorPoolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_pool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorPool), 0, (GInstanceInitFunc) library_monitor_pool_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType library_monitor_pool_type_id;
		library_monitor_pool_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorPool", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&library_monitor_pool_type_id__volatile, library_monitor_pool_type_id);
	}
	return library_monitor_pool_type_id__volatile;
}


gpointer library_monitor_pool_ref (gpointer instance) {
	LibraryMonitorPool* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void library_monitor_pool_unref (gpointer instance) {
	LibraryMonitorPool* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		LIBRARY_MONITOR_POOL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _library_monitor_on_config_changed_configuration_facade_auto_import_from_library_changed (ConfigurationFacade* _sender, gpointer self) {
	library_monitor_on_config_changed (self);
}


static void _library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item, gpointer self) {
	library_monitor_on_unblacklist_file (item);
}


static gboolean _library_monitor_on_flush_import_queue_gsource_func (gpointer self) {
	gboolean result;
	result = library_monitor_on_flush_import_queue (self);
	return result;
}


LibraryMonitor* library_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
	LibraryMonitor * self = NULL;
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_;
	gboolean _tmp2_;
	ConfigFacade* _tmp3_ = NULL;
	ConfigFacade* _tmp4_;
	guint _tmp5_;
	g_return_val_if_fail (G_IS_FILE (root), NULL);
	self = (LibraryMonitor*) directory_monitor_construct (object_type, root, recurse, monitoring);
	_tmp0_ = config_facade_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = configuration_facade_get_auto_import_from_library (CONFIGURATION_FACADE (_tmp1_));
	self->priv->auto_import = _tmp2_;
	_g_object_unref0 (_tmp1_);
	_tmp3_ = config_facade_get_instance ();
	_tmp4_ = _tmp3_;
	g_signal_connect_object (CONFIGURATION_FACADE (_tmp4_), "auto-import-from-library-changed", (GCallback) _library_monitor_on_config_changed_configuration_facade_auto_import_from_library_changed, self, 0);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC, _library_monitor_on_flush_import_queue_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->import_queue_timer_id = _tmp5_;
	return self;
}


LibraryMonitor* library_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
	return library_monitor_construct (TYPE_LIBRARY_MONITOR, root, recurse, monitoring);
}


static void library_monitor_real_close (DirectoryMonitor* base) {
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (base);
	g_cancellable_cancel (self->priv->cancellable);
	{
		GeeList* _tmp0_;
		GeeList* _monitor_list;
		gint _tmp1_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp0_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp1_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			MediaMonitor* monitor;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp2_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp2_;
			media_monitor_close (monitor);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (self->priv->import_queue_timer_id != 0) {
		g_source_remove (self->priv->import_queue_timer_id);
		self->priv->import_queue_timer_id = (guint) 0;
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->close (DIRECTORY_MONITOR (self));
}


static void library_monitor_add_to_discovered_list (LibraryMonitor* self, MediaMonitor* monitor, Monitorable* monitorable) {
	gboolean _tmp0_;
	gpointer _tmp3_ = NULL;
	GeeSet* _tmp4_;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (IS_MEDIA_MONITOR (monitor));
	g_return_if_fail (IS_MONITORABLE (monitorable));
	_tmp0_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->discovered), monitor);
	if (!_tmp0_) {
		GeeHashSet* _tmp1_ = NULL;
		GeeHashSet* _tmp2_;
		_tmp1_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
		_tmp2_ = _tmp1_;
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->discovered), monitor, GEE_SET (_tmp2_));
		_g_object_unref0 (_tmp2_);
	}
	_tmp3_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->discovered), monitor);
	_tmp4_ = (GeeSet*) _tmp3_;
	gee_collection_add (GEE_COLLECTION (_tmp4_), monitorable);
	_g_object_unref0 (_tmp4_);
}


static MediaMonitor* library_monitor_get_monitor_for_monitorable (LibraryMonitor* self, Monitorable* monitorable) {
	MediaMonitor* result = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	g_return_val_if_fail (IS_LIBRARY_MONITOR (self), NULL);
	g_return_val_if_fail (IS_MONITORABLE (monitorable), NULL);
	{
		GeeList* _tmp0_;
		GeeList* _monitor_list;
		gint _tmp1_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp0_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp1_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			MediaMonitor* monitor;
			MediaSourceCollection* _tmp3_ = NULL;
			MediaSourceCollection* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp2_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp2_;
			_tmp3_ = media_monitor_get_media_source_collection (monitor);
			_tmp4_ = _tmp3_;
			_tmp5_ = source_collection_holds_type_of_source (SOURCE_COLLECTION (_tmp4_), DATA_SOURCE (monitorable));
			_tmp6_ = _tmp5_;
			_data_collection_unref0 (_tmp4_);
			if (_tmp6_) {
				result = monitor;
				_g_object_unref0 (_monitor_list);
				return result;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	_tmp7_ = data_object_to_string (DATA_OBJECT (monitorable));
	_tmp8_ = _tmp7_;
	g_error ("LibraryMonitor.vala:277: Unable to locate MediaMonitor for %s", _tmp8_);
	_g_free0 (_tmp8_);
}


static void library_monitor_real_discovery_started (DirectoryMonitor* base) {
	LibraryMonitor * self;
	GeeHashMap* _tmp13_ = NULL;
	GeeHashSet* _tmp14_ = NULL;
	self = LIBRARY_MONITOR (base);
	{
		MediaCollectionRegistry* _tmp0_ = NULL;
		MediaCollectionRegistry* _tmp1_;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _collection_it;
		_tmp0_ = media_collection_registry_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = media_collection_registry_get_all (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_media_collection_registry_unref0 (_tmp1_);
		_collection_it = _tmp5_;
		while (TRUE) {
			gboolean _tmp6_;
			gpointer _tmp7_ = NULL;
			MediaSourceCollection* collection;
			MediaMonitor* _tmp8_ = NULL;
			MediaMonitor* _tmp9_;
			_tmp6_ = gee_iterator_next (_collection_it);
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = gee_iterator_get (_collection_it);
			collection = (MediaSourceCollection*) _tmp7_;
			_tmp8_ = media_source_collection_create_media_monitor (collection, self->priv->workers, self->priv->cancellable);
			_tmp9_ = _tmp8_;
			gee_collection_add (GEE_COLLECTION (self->priv->monitors), _tmp9_);
			_g_object_unref0 (_tmp9_);
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
	{
		GeeList* _tmp10_;
		GeeList* _monitor_list;
		gint _tmp11_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp10_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp10_;
		_tmp11_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp11_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp12_ = NULL;
			MediaMonitor* monitor;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp12_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp12_;
			media_monitor_notify_discovery_started (monitor);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	_tmp13_ = gee_hash_map_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->discovered);
	self->priv->discovered = _tmp13_;
	_tmp14_ = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	_g_object_unref0 (self->priv->unknown_files);
	self->priv->unknown_files = _tmp14_;
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_started (DIRECTORY_MONITOR (self));
}


static void library_monitor_real_file_discovered (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
	LibraryMonitor * self;
	Monitorable* representation;
	MediaMonitor* representing;
	gboolean ignore;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	representation = NULL;
	representing = NULL;
	ignore = FALSE;
	{
		GeeList* _tmp0_;
		GeeList* _monitor_list;
		gint _tmp1_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp0_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp1_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			MediaMonitor* monitor;
			Monitorable* _tmp3_ = NULL;
			MediaMonitorDiscoveredFile _tmp4_;
			MediaMonitorDiscoveredFile _result_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp2_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp2_;
			_tmp4_ = media_monitor_notify_file_discovered (monitor, file, info, &_tmp3_);
			_g_object_unref0 (representation);
			representation = _tmp3_;
			_result_ = _tmp4_;
			if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
				MediaMonitor* _tmp5_;
				_tmp5_ = _g_object_ref0 (monitor);
				_g_object_unref0 (representing);
				representing = _tmp5_;
				_g_object_unref0 (monitor);
				break;
			} else {
				if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE) {
					ignore = TRUE;
					_g_object_unref0 (monitor);
					break;
				}
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (representing != NULL) {
		gboolean _tmp6_ = FALSE;
		if (representation != NULL) {
			_tmp6_ = !ignore;
		} else {
			_tmp6_ = FALSE;
		}
		g_assert (_tmp6_);
		library_monitor_add_to_discovered_list (self, representing, representation);
	} else {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		if (!ignore) {
			gboolean _tmp9_;
			_tmp9_ = tombstone_source_collection_matches (tombstone_global, file);
			_tmp8_ = !_tmp9_;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			gboolean _tmp10_;
			_tmp10_ = library_monitor_is_supported_filetype (self, file);
			_tmp7_ = _tmp10_;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->unknown_files), file);
		}
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->file_discovered (DIRECTORY_MONITOR (self), file, info);
	_g_object_unref0 (representing);
	_g_object_unref0 (representation);
}


static void library_monitor_real_discovery_completed (DirectoryMonitor* base) {
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (base);
	library_monitor_async_discovery_completed (self, NULL, NULL);
}


static void library_monitor_async_discovery_completed_data_free (gpointer _data) {
	LibraryMonitorAsyncDiscoveryCompletedData* data;
	data = _data;
	_g_object_unref0 (data->self);
	g_slice_free (LibraryMonitorAsyncDiscoveryCompletedData, data);
}


static void library_monitor_async_discovery_completed (LibraryMonitor* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	_data_ = g_slice_new0 (LibraryMonitorAsyncDiscoveryCompletedData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, library_monitor_async_discovery_completed);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, library_monitor_async_discovery_completed_data_free);
	_data_->self = _g_object_ref0 (self);
	library_monitor_async_discovery_completed_co (_data_);
}


static void library_monitor_async_discovery_completed_finish (LibraryMonitor* self, GAsyncResult* _res_) {
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static gboolean _library_monitor_async_discovery_completed_co_gsource_func (gpointer self) {
	gboolean result;
	result = library_monitor_async_discovery_completed_co (self);
	return result;
}


static gboolean library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = gee_collection_get_size (GEE_COLLECTION (data->self->priv->unknown_files));
	if (data->_tmp0_ == 0) {
		library_monitor_discovery_stage_completed (data->self);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp1_ = NULL;
	data->_tmp1_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	data->all_candidates = data->_tmp1_;
	data->_tmp2_ = NULL;
	data->_tmp2_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->adopted = data->_tmp2_;
	{
		data->_tmp3_ = NULL;
		data->_tmp3_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (data->self->priv->unknown_files));
		data->_file_it = data->_tmp3_;
		while (TRUE) {
			data->_tmp4_ = gee_iterator_next (data->_file_it);
			if (!data->_tmp4_) {
				break;
			}
			data->_tmp5_ = NULL;
			data->_tmp5_ = gee_iterator_get (data->_file_it);
			data->file = (GFile*) data->_tmp5_;
			data->_tmp6_ = NULL;
			data->_tmp6_ = directory_monitor_get_file_info (DIRECTORY_MONITOR (data->self), data->file);
			data->info = data->_tmp6_;
			if (data->info == NULL) {
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->file);
				continue;
			}
			gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (data->all_candidates));
			data->candidates = NULL;
			data->associated = FALSE;
			{
				data->_tmp7_ = _g_object_ref0 (data->self->priv->monitors);
				data->_monitor_list = data->_tmp7_;
				data->_tmp8_ = gee_collection_get_size (GEE_COLLECTION (data->_monitor_list));
				data->_monitor_size = data->_tmp8_;
				data->_monitor_index = -1;
				while (TRUE) {
					data->_monitor_index = data->_monitor_index + 1;
					if (!(data->_monitor_index < data->_monitor_size)) {
						break;
					}
					data->_tmp9_ = NULL;
					data->_tmp9_ = gee_list_get (data->_monitor_list, data->_monitor_index);
					data->monitor = (MediaMonitor*) data->_tmp9_;
					data->_tmp11_ = NULL;
					data->_tmp11_ = media_monitor_candidates_for_unknown_file (data->monitor, data->file, data->info, &data->_tmp10_);
					data->_result_ = data->_tmp10_;
					_g_object_unref0 (data->candidates);
					data->candidates = data->_tmp11_;
					if (data->_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
						data->_tmp12_ = TRUE;
					} else {
						data->_tmp12_ = data->_result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
					}
					if (data->_tmp12_) {
						data->associated = TRUE;
						_g_object_unref0 (data->monitor);
						break;
					} else {
						if (data->candidates != NULL) {
							gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (data->all_candidates), data->candidates);
						}
					}
					_g_object_unref0 (data->monitor);
				}
				_g_object_unref0 (data->_monitor_list);
			}
			if (data->associated) {
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (data->adopted), data->file);
				_g_object_unref0 (data->candidates);
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->file);
				continue;
			}
			data->_tmp13_ = gee_collection_get_size (GEE_COLLECTION (data->all_candidates));
			if (data->_tmp13_ > 0) {
				data->_tmp14_ = _g_object_ref0 (data->all_candidates);
				data->job_candidates = data->_tmp14_;
				data->_tmp15_ = NULL;
				data->_tmp15_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
				_g_object_unref0 (data->all_candidates);
				data->all_candidates = data->_tmp15_;
				data->self->priv->checksums_total++;
				data->_tmp16_ = NULL;
				data->_tmp16_ = library_monitor_find_move_job_new (data->self, data->file, GEE_COLLECTION (data->job_candidates));
				data->_tmp17_ = data->_tmp16_;
				workers_enqueue (data->self->priv->workers, BACKGROUND_JOB (data->_tmp17_));
				_background_job_unref0 (data->_tmp17_);
				_g_object_unref0 (data->job_candidates);
			}
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _library_monitor_async_discovery_completed_co_gsource_func, data, NULL);
			data->_state_ = 1;
			return FALSE;
			_state_1:
			;
			_g_object_unref0 (data->candidates);
			_g_object_unref0 (data->info);
			_g_object_unref0 (data->file);
		}
		_g_object_unref0 (data->_file_it);
	}
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (data->self->priv->unknown_files), GEE_COLLECTION (data->adopted));
	data->self->priv->checksums_completed = 0;
	if (data->self->priv->checksums_total == 0) {
		library_monitor_discovery_stage_completed (data->self);
	} else {
		data->_tmp18_ = NULL;
		data->_tmp18_ = g_strdup_printf ("%d checksum jobs initiated to verify unknown photo files", data->self->priv->checksums_total);
		data->_tmp19_ = data->_tmp18_;
		directory_monitor_mdbg (data->_tmp19_);
		_g_free0 (data->_tmp19_);
		g_signal_emit_by_name (data->self, "auto-update-progress", data->self->priv->checksums_completed, data->self->priv->checksums_total);
	}
	_g_object_unref0 (data->adopted);
	_g_object_unref0 (data->all_candidates);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void library_monitor_report_checksum_job_completed (LibraryMonitor* self) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_assert (self->priv->checksums_completed < self->priv->checksums_total);
	self->priv->checksums_completed++;
	g_signal_emit_by_name (self, "auto-update-progress", self->priv->checksums_completed, self->priv->checksums_total);
	if (self->priv->checksums_completed == self->priv->checksums_total) {
		library_monitor_discovery_stage_completed (self);
	}
}


static gpointer _background_job_ref0 (gpointer self) {
	return self ? background_job_ref (self) : NULL;
}


static void library_monitor_on_find_move_completed (LibraryMonitor* self, BackgroundJob* j) {
	LibraryMonitorFindMoveJob* _tmp0_;
	LibraryMonitorFindMoveJob* job;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (IS_BACKGROUND_JOB (j));
	_tmp0_ = _background_job_ref0 (LIBRARY_MONITOR_FIND_MOVE_JOB (j));
	job = _tmp0_;
	if (job->match != NULL) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		MediaMonitor* _tmp7_ = NULL;
		MediaMonitor* monitor;
		_tmp1_ = g_file_get_path (job->file);
		_tmp2_ = _tmp1_;
		_tmp3_ = data_object_to_string (DATA_OBJECT (job->match));
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup_printf ("Found moved master file: %s matches %s", _tmp2_, _tmp4_);
		_tmp6_ = _tmp5_;
		directory_monitor_mdbg (_tmp6_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
		_tmp7_ = library_monitor_get_monitor_for_monitorable (self, job->match);
		monitor = _tmp7_;
		media_monitor_update_master_file (monitor, job->match, job->file);
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->unknown_files), job->file);
		library_monitor_add_to_discovered_list (self, monitor, job->match);
		_g_object_unref0 (monitor);
	}
	if (job->err != NULL) {
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp8_ = g_file_get_path (job->file);
		_tmp9_ = _tmp8_;
		g_warning ("LibraryMonitor.vala:422: Unable to checksum unknown media file %s: %s", _tmp9_, job->err->message);
		_g_free0 (_tmp9_);
	}
	library_monitor_report_checksum_job_completed (self);
	_background_job_unref0 (job);
}


static void library_monitor_on_find_move_cancelled (LibraryMonitor* self, BackgroundJob* j) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (IS_BACKGROUND_JOB (j));
	library_monitor_report_checksum_job_completed (self);
}


static void library_monitor_discovery_stage_completed (LibraryMonitor* self) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	{
		GeeList* _tmp0_;
		GeeList* _monitor_list;
		gint _tmp1_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp0_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp1_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			MediaMonitor* monitor;
			gpointer _tmp3_ = NULL;
			GeeSet* monitorables;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp2_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp2_;
			_tmp3_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->discovered), monitor);
			monitorables = (GeeSet*) _tmp3_;
			if (monitorables != NULL) {
				{
					GeeIterator* _tmp4_ = NULL;
					GeeIterator* _monitorable_it;
					_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (monitorables));
					_monitorable_it = _tmp4_;
					while (TRUE) {
						gboolean _tmp5_;
						gpointer _tmp6_ = NULL;
						Monitorable* monitorable;
						_tmp5_ = gee_iterator_next (_monitorable_it);
						if (!_tmp5_) {
							break;
						}
						_tmp6_ = gee_iterator_get (_monitorable_it);
						monitorable = (Monitorable*) _tmp6_;
						library_monitor_enqueue_verify_monitorable (self, monitorable, monitor);
						_g_object_unref0 (monitorable);
					}
					_g_object_unref0 (_monitorable_it);
				}
			}
			{
				MediaSourceCollection* _tmp7_ = NULL;
				MediaSourceCollection* _tmp8_;
				GeeCollection* _tmp9_ = NULL;
				GeeCollection* _tmp10_;
				GeeIterator* _tmp11_ = NULL;
				GeeIterator* _tmp12_;
				GeeIterator* _object_it;
				_tmp7_ = media_monitor_get_media_source_collection (monitor);
				_tmp8_ = _tmp7_;
				_tmp9_ = data_collection_get_all (DATA_COLLECTION (_tmp8_));
				_tmp10_ = _tmp9_;
				_tmp11_ = gee_iterable_iterator (GEE_ITERABLE (_tmp10_));
				_tmp12_ = _tmp11_;
				_g_object_unref0 (_tmp10_);
				_data_collection_unref0 (_tmp8_);
				_object_it = _tmp12_;
				while (TRUE) {
					gboolean _tmp13_;
					gpointer _tmp14_ = NULL;
					DataObject* object;
					Monitorable* _tmp15_;
					Monitorable* monitorable;
					gboolean _tmp16_ = FALSE;
					_tmp13_ = gee_iterator_next (_object_it);
					if (!_tmp13_) {
						break;
					}
					_tmp14_ = gee_iterator_get (_object_it);
					object = (DataObject*) _tmp14_;
					_tmp15_ = _g_object_ref0 (MONITORABLE (object));
					monitorable = _tmp15_;
					if (monitorables != NULL) {
						gboolean _tmp17_;
						_tmp17_ = gee_collection_contains (GEE_COLLECTION (monitorables), monitorable);
						_tmp16_ = _tmp17_;
					} else {
						_tmp16_ = FALSE;
					}
					if (_tmp16_) {
						_g_object_unref0 (monitorable);
						_g_object_unref0 (object);
						continue;
					}
					library_monitor_enqueue_verify_monitorable (self, monitorable, monitor);
					_g_object_unref0 (monitorable);
					_g_object_unref0 (object);
				}
				_g_object_unref0 (_object_it);
			}
			{
				MediaSourceCollection* _tmp18_ = NULL;
				MediaSourceCollection* _tmp19_;
				MediaSourceHoldingTank* _tmp20_ = NULL;
				MediaSourceHoldingTank* _tmp21_;
				GeeCollection* _tmp22_ = NULL;
				GeeCollection* _tmp23_;
				GeeIterator* _tmp24_ = NULL;
				GeeIterator* _tmp25_;
				GeeIterator* _source_it;
				_tmp18_ = media_monitor_get_media_source_collection (monitor);
				_tmp19_ = _tmp18_;
				_tmp20_ = media_source_collection_get_offline_bin (_tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = source_holding_tank_get_all (SOURCE_HOLDING_TANK (_tmp21_));
				_tmp23_ = _tmp22_;
				_tmp24_ = gee_iterable_iterator (GEE_ITERABLE (_tmp23_));
				_tmp25_ = _tmp24_;
				_g_object_unref0 (_tmp23_);
				_source_holding_tank_unref0 (_tmp21_);
				_data_collection_unref0 (_tmp19_);
				_source_it = _tmp25_;
				while (TRUE) {
					gboolean _tmp26_;
					gpointer _tmp27_ = NULL;
					DataSource* source;
					Monitorable* _tmp28_;
					Monitorable* monitorable;
					gboolean _tmp29_ = FALSE;
					_tmp26_ = gee_iterator_next (_source_it);
					if (!_tmp26_) {
						break;
					}
					_tmp27_ = gee_iterator_get (_source_it);
					source = (DataSource*) _tmp27_;
					_tmp28_ = _g_object_ref0 (MONITORABLE (source));
					monitorable = _tmp28_;
					if (monitorables != NULL) {
						gboolean _tmp30_;
						_tmp30_ = gee_collection_contains (GEE_COLLECTION (monitorables), monitorable);
						_tmp29_ = _tmp30_;
					} else {
						_tmp29_ = FALSE;
					}
					if (_tmp29_) {
						_g_object_unref0 (monitorable);
						_g_object_unref0 (source);
						continue;
					}
					library_monitor_enqueue_verify_monitorable (self, monitorable, monitor);
					_g_object_unref0 (monitorable);
					_g_object_unref0 (source);
				}
				_g_object_unref0 (_source_it);
			}
			_g_object_unref0 (monitorables);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (self->priv->auto_import) {
		library_monitor_enqueue_import_many (self, GEE_COLLECTION (self->priv->unknown_files));
	}
	_g_object_unref0 (self->priv->discovered);
	self->priv->discovered = NULL;
	_g_object_unref0 (self->priv->unknown_files);
	self->priv->unknown_files = NULL;
	tombstone_source_collection_launch_scan (tombstone_global, DIRECTORY_MONITOR (self), self->priv->cancellable);
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_completed (DIRECTORY_MONITOR (self));
}


static void library_monitor_enqueue_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor) {
	LibraryMonitorVerifyJob* _tmp0_ = NULL;
	LibraryMonitorVerifyJob* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean offered;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (IS_MONITORABLE (monitorable));
	g_return_if_fail (IS_MEDIA_MONITOR (monitor));
	_tmp0_ = library_monitor_verify_job_new (monitorable, monitor);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_queue_offer (self->priv->verify_queue, _tmp1_);
	_tmp3_ = _tmp2_;
	_library_monitor_verify_job_unref0 (_tmp1_);
	offered = _tmp3_;
	g_assert (offered);
	library_monitor_execute_next_verify_job (self);
}


static void library_monitor_execute_next_verify_job (LibraryMonitor* self) {
	gboolean _tmp0_ = FALSE;
	gpointer _tmp2_ = NULL;
	LibraryMonitorVerifyJob* job;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	if (self->priv->outstanding_verify_jobs >= LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (self->priv->verify_queue));
		_tmp0_ = _tmp1_ == 0;
	}
	if (_tmp0_) {
		return;
	}
	_tmp2_ = gee_queue_poll (self->priv->verify_queue);
	job = (LibraryMonitorVerifyJob*) _tmp2_;
	g_assert (job != NULL);
	self->priv->outstanding_verify_jobs++;
	library_monitor_verify_monitorable (self, job->monitorable, job->monitor, NULL, NULL);
	_library_monitor_verify_job_unref0 (job);
}


static void library_monitor_verify_monitorable_data_free (gpointer _data) {
	LibraryMonitorVerifyMonitorableData* data;
	data = _data;
	_g_object_unref0 (data->monitorable);
	_g_object_unref0 (data->monitor);
	_g_object_unref0 (data->self);
	g_slice_free (LibraryMonitorVerifyMonitorableData, data);
}


static void library_monitor_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	LibraryMonitorVerifyMonitorableData* _data_;
	_data_ = g_slice_new0 (LibraryMonitorVerifyMonitorableData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, library_monitor_verify_monitorable);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, library_monitor_verify_monitorable_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->monitorable = _g_object_ref0 (monitorable);
	_data_->monitor = _g_object_ref0 (monitor);
	library_monitor_verify_monitorable_co (_data_);
}


static void library_monitor_verify_monitorable_finish (LibraryMonitor* self, GAsyncResult* _res_) {
	LibraryMonitorVerifyMonitorableData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void _vala_array_add278 (GFile*** array, int* length, int* size, GFile* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void library_monitor_verify_monitorable_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	LibraryMonitorVerifyMonitorableData* data;
	data = _user_data_;
	data->_source_object_ = source_object;
	data->_res_ = _res_;
	library_monitor_verify_monitorable_co (data);
}


static gboolean _library_monitor_verify_monitorable_co_gsource_func (gpointer self) {
	gboolean result;
	result = library_monitor_verify_monitorable_co (self);
	return result;
}


static gboolean library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = NULL;
	data->_tmp0_ = g_new0 (GFile*, 1 + 1);
	data->files = data->_tmp0_;
	data->files_length1 = 1;
	data->_files_size_ = 1;
	data->_tmp1_ = NULL;
	data->_tmp1_ = media_monitor_get_master_file (data->monitor, data->monitorable);
	data->_tmp2_ = data->_tmp1_;
	_g_object_unref0 (data->files[0]);
	data->files[0] = data->_tmp2_;
	data->_tmp4_ = NULL;
	data->_tmp4_ = media_monitor_get_auxilliary_backing_files (data->monitor, data->monitorable, &data->_tmp3_);
	data->aux_files = data->_tmp4_;
	data->aux_files_length1 = data->_tmp3_;
	data->_aux_files_size_ = data->_tmp3_;
	if (data->aux_files != NULL) {
		{
			data->aux_file_collection = data->aux_files;
			data->aux_file_collection_length1 = data->aux_files_length1;
			for (data->aux_file_it = 0; data->aux_file_it < data->aux_files_length1; data->aux_file_it = data->aux_file_it + 1) {
				data->_tmp5_ = _g_object_ref0 (data->aux_file_collection[data->aux_file_it]);
				data->aux_file = data->_tmp5_;
				{
					data->_tmp6_ = _g_object_ref0 (data->aux_file);
					_vala_array_add278 (&data->files, &data->files_length1, &data->_files_size_, data->_tmp6_);
					_g_object_unref0 (data->aux_file);
				}
			}
		}
	}
	{
		data->ctr = 0;
		{
			data->_tmp7_ = TRUE;
			while (TRUE) {
				if (!data->_tmp7_) {
					data->ctr++;
				}
				data->_tmp7_ = FALSE;
				if (!(data->ctr < data->files_length1)) {
					break;
				}
				data->_tmp8_ = _g_object_ref0 (data->files[data->ctr]);
				data->file = data->_tmp8_;
				data->_tmp9_ = NULL;
				data->_tmp9_ = directory_monitor_get_file_info (DIRECTORY_MONITOR (data->self), data->file);
				data->info = data->_tmp9_;
				if (data->info == NULL) {
					data->_state_ = 1;
					g_file_query_info_async (data->file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_FILE_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, library_monitor_verify_monitorable_ready, data);
					return FALSE;
					_state_1:
					data->_tmp10_ = NULL;
					data->_tmp10_ = g_file_query_info_finish (data->file, data->_res_, &data->_inner_error_);
					data->_tmp11_ = data->_tmp10_;
					if (data->_inner_error_ != NULL) {
						goto __catch446_g_error;
					}
					_g_object_unref0 (data->info);
					data->info = data->_tmp11_;
					goto __finally446;
					__catch446_g_error:
					{
						data->err = data->_inner_error_;
						data->_inner_error_ = NULL;
						_g_error_free0 (data->err);
					}
					__finally446:
					if (data->_inner_error_ != NULL) {
						_g_object_unref0 (data->info);
						_g_object_unref0 (data->file);
						data->aux_files = (_vala_array_free (data->aux_files, data->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
						data->files = (_vala_array_free (data->files, data->files_length1, (GDestroyNotify) g_object_unref), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
						g_clear_error (&data->_inner_error_);
						return FALSE;
					}
				}
				if (data->ctr == 0) {
					if (data->info != NULL) {
						data->_tmp13_ = media_monitor_is_offline (data->monitor, data->monitorable);
						data->_tmp12_ = data->_tmp13_;
					} else {
						data->_tmp12_ = FALSE;
					}
					if (data->_tmp12_) {
						media_monitor_update_online (data->monitor, data->monitorable);
					} else {
						if (data->info == NULL) {
							data->_tmp15_ = media_monitor_is_offline (data->monitor, data->monitorable);
							data->_tmp14_ = !data->_tmp15_;
						} else {
							data->_tmp14_ = FALSE;
						}
						if (data->_tmp14_) {
							media_monitor_update_offline (data->monitor, data->monitorable);
						}
					}
				}
				media_monitor_update_backing_file_info (data->monitor, data->monitorable, data->file, data->info);
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->file);
			}
		}
	}
	data->self->priv->completed_monitorable_verifies++;
	g_signal_emit_by_name (data->self, "auto-update-progress", data->self->priv->completed_monitorable_verifies, data->self->priv->total_monitorable_verifies);
	g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _library_monitor_verify_monitorable_co_gsource_func, data, NULL);
	data->_state_ = 2;
	return FALSE;
	_state_2:
	;
	g_assert (data->self->priv->outstanding_verify_jobs > 0);
	data->self->priv->outstanding_verify_jobs--;
	library_monitor_execute_next_verify_job (data->self);
	data->aux_files = (_vala_array_free (data->aux_files, data->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
	data->files = (_vala_array_free (data->files, data->files_length1, (GDestroyNotify) g_object_unref), NULL);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void library_monitor_on_config_changed (LibraryMonitor* self) {
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean value;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	_tmp0_ = config_facade_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = configuration_facade_get_auto_import_from_library (CONFIGURATION_FACADE (_tmp1_));
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	value = _tmp3_;
	if (self->priv->auto_import == value) {
		return;
	}
	self->priv->auto_import = value;
	if (self->priv->auto_import) {
		if (!commandline_options_no_runtime_monitoring) {
			library_monitor_import_unrepresented_files (self);
		}
	} else {
		library_monitor_cancel_batch_imports (self);
	}
}


static void library_monitor_enqueue_import (LibraryMonitor* self, GFile* file) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp2_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), file);
	if (!_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = library_monitor_is_supported_filetype (self, file);
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp4_;
		_tmp4_ = library_monitor_is_blacklisted (file);
		_tmp0_ = !_tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->import_queue), file);
	}
}


static void library_monitor_enqueue_import_many (LibraryMonitor* self, GeeCollection* files) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (GEE_IS_COLLECTION (files));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _file_it;
		_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (files));
		_file_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			GFile* file;
			_tmp1_ = gee_iterator_next (_file_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp2_;
			library_monitor_enqueue_import (self, file);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
}


static void library_monitor_remove_queued_import (LibraryMonitor* self, GFile* file) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->import_queue), file);
}


static gboolean library_monitor_on_flush_import_queue (LibraryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gulong _tmp5_;
	time_t now;
	gboolean _tmp6_ = FALSE;
	GeeArrayList* _tmp8_ = NULL;
	GeeArrayList* jobs;
	BatchImport* _tmp15_ = NULL;
	BatchImport* importer;
	g_return_val_if_fail (IS_LIBRARY_MONITOR (self), FALSE);
	_tmp0_ = g_cancellable_is_cancelled (self->priv->cancellable);
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gee_collection_get_size (GEE_COLLECTION (self->priv->import_queue));
	if (_tmp1_ == 0) {
		result = TRUE;
		return result;
	}
	if (self->priv->current_batch_import != NULL) {
		result = TRUE;
		return result;
	}
	_tmp2_ = gee_collection_get_size (GEE_COLLECTION (self->priv->import_queue));
	_tmp3_ = g_strdup_printf ("Auto-importing %d files", _tmp2_);
	_tmp4_ = _tmp3_;
	directory_monitor_mdbg (_tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = now_sec ();
	now = (time_t) _tmp5_;
	if (self->priv->current_import_roll == NULL) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = (now - self->priv->last_import_roll_use) >= LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC;
	}
	if (_tmp6_) {
		BatchImportRoll* _tmp7_ = NULL;
		_tmp7_ = batch_import_roll_new ();
		_batch_import_roll_unref0 (self->priv->current_import_roll);
		self->priv->current_import_roll = _tmp7_;
	}
	self->priv->last_import_roll_use = now;
	_tmp8_ = gee_array_list_new (TYPE_BATCH_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, batch_import_job_unref, NULL);
	jobs = _tmp8_;
	{
		GeeIterator* _tmp9_ = NULL;
		GeeIterator* _file_it;
		_tmp9_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->import_queue));
		_file_it = _tmp9_;
		while (TRUE) {
			gboolean _tmp10_;
			gpointer _tmp11_ = NULL;
			GFile* file;
			gboolean _tmp12_;
			FileImportJob* _tmp13_ = NULL;
			FileImportJob* _tmp14_;
			_tmp10_ = gee_iterator_next (_file_it);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp11_;
			_tmp12_ = library_monitor_is_blacklisted (file);
			if (_tmp12_) {
				_g_object_unref0 (file);
				continue;
			}
			_tmp13_ = file_import_job_new (file, FALSE);
			_tmp14_ = _tmp13_;
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (jobs), BATCH_IMPORT_JOB (_tmp14_));
			_batch_import_job_unref0 (_tmp14_);
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), file);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->import_queue));
	_tmp15_ = batch_import_new (GEE_ITERABLE (jobs), "LibraryMonitor autoimport", NULL, NULL, NULL, NULL, NULL, self->priv->current_import_roll, NULL);
	importer = _tmp15_;
	batch_import_set_untrash_duplicates (importer, FALSE);
	batch_import_set_mark_duplicates_online (importer, FALSE);
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->batch_import_queue), importer);
	library_monitor_schedule_next_batch_import (self);
	result = TRUE;
	_g_object_unref0 (importer);
	_g_object_unref0 (jobs);
	return result;
}


static void _library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender, gpointer self) {
	library_monitor_on_import_preparing (self);
}


static void _library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender, guint64 completed_bytes, guint64 total_bytes, gpointer self) {
	library_monitor_on_import_progress (self, completed_bytes, total_bytes);
}


static void _library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender, ImportManifest* manifest, BatchImportRoll* import_roll, gpointer self) {
	library_monitor_on_import_complete (self, _sender, manifest, import_roll);
}


static void library_monitor_schedule_next_batch_import (LibraryMonitor* self) {
	gboolean _tmp0_ = FALSE;
	gpointer _tmp2_ = NULL;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	if (self->priv->current_batch_import != NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (self->priv->batch_import_queue));
		_tmp0_ = _tmp1_ == 0;
	}
	if (_tmp0_) {
		return;
	}
	_tmp2_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->batch_import_queue), 0);
	_g_object_unref0 (self->priv->current_batch_import);
	self->priv->current_batch_import = (BatchImport*) _tmp2_;
	g_signal_connect_object (self->priv->current_batch_import, "preparing", (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self, 0);
	g_signal_connect_object (self->priv->current_batch_import, "progress", (GCallback) _library_monitor_on_import_progress_batch_import_progress, self, 0);
	g_signal_connect_object (self->priv->current_batch_import, "import-complete", (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self, 0);
	batch_import_schedule (self->priv->current_batch_import);
}


static void library_monitor_discard_current_batch_import (LibraryMonitor* self) {
	gboolean _tmp0_;
	gboolean removed;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gint _tmp4_;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_assert (self->priv->current_batch_import != NULL);
	_tmp0_ = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->batch_import_queue), self->priv->current_batch_import);
	removed = _tmp0_;
	g_assert (removed);
	g_signal_parse_name ("preparing", TYPE_BATCH_IMPORT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->current_batch_import, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self);
	g_signal_parse_name ("progress", TYPE_BATCH_IMPORT, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->current_batch_import, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _library_monitor_on_import_progress_batch_import_progress, self);
	g_signal_parse_name ("import-complete", TYPE_BATCH_IMPORT, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->current_batch_import, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self);
	_g_object_unref0 (self->priv->current_batch_import);
	self->priv->current_batch_import = NULL;
	_tmp4_ = gee_collection_get_size (GEE_COLLECTION (self->priv->batch_import_queue));
	if (_tmp4_ == 0) {
		gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports));
	}
}


static void library_monitor_cancel_batch_imports (LibraryMonitor* self) {
	gint ctr;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	ctr = 0;
	while (TRUE) {
		gint _tmp0_;
		gpointer _tmp1_ = NULL;
		BatchImport* _tmp2_;
		gboolean _tmp3_;
		gpointer _tmp4_ = NULL;
		BatchImport* _tmp5_;
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->batch_import_queue));
		if (!(ctr < _tmp0_)) {
			break;
		}
		_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->batch_import_queue), ctr);
		_tmp2_ = (BatchImport*) _tmp1_;
		_tmp3_ = _tmp2_ == self->priv->current_batch_import;
		_g_object_unref0 (_tmp2_);
		if (_tmp3_) {
			ctr++;
			continue;
		}
		_tmp4_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->batch_import_queue), ctr);
		_tmp5_ = (BatchImport*) _tmp4_;
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->batch_import_queue), _tmp5_);
		_g_object_unref0 (_tmp5_);
	}
	if (self->priv->current_batch_import != NULL) {
		batch_import_user_halt (self->priv->current_batch_import);
	}
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports));
}


static void library_monitor_on_import_preparing (LibraryMonitor* self) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_signal_emit_by_name (self, "auto-import-preparing");
}


static void library_monitor_on_import_progress (LibraryMonitor* self, guint64 completed_bytes, guint64 total_bytes) {
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_signal_emit_by_name (self, "auto-import-progress", completed_bytes, total_bytes);
}


static void library_monitor_on_import_complete (LibraryMonitor* self, BatchImport* batch_import, ImportManifest* manifest, BatchImportRoll* import_roll) {
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gint _tmp6_;
	gint _tmp17_;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (IS_BATCH_IMPORT (batch_import));
	g_return_if_fail (IS_IMPORT_MANIFEST (manifest));
	g_return_if_fail (IS_BATCH_IMPORT_ROLL (import_roll));
	g_assert (batch_import == self->priv->current_batch_import);
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (manifest->all));
	_tmp1_ = g_strdup_printf ("auto-import batch completed %d", _tmp0_);
	_tmp2_ = _tmp1_;
	directory_monitor_mdbg (_tmp2_);
	_g_free0 (_tmp2_);
	g_signal_emit_by_name (self, "auto-import-progress", (guint64) 0, (guint64) 0);
	{
		GeeList* _tmp3_;
		GeeList* _result_list;
		gint _tmp4_;
		gint _result_size;
		gint _result_index;
		_tmp3_ = _g_object_ref0 (manifest->all);
		_result_list = _tmp3_;
		_tmp4_ = gee_collection_get_size (GEE_COLLECTION (_result_list));
		_result_size = _tmp4_;
		_result_index = -1;
		while (TRUE) {
			gpointer _tmp5_ = NULL;
			BatchImportResult* _result_;
			_result_index = _result_index + 1;
			if (!(_result_index < _result_size)) {
				break;
			}
			_tmp5_ = gee_list_get (_result_list, _result_index);
			_result_ = (BatchImportResult*) _tmp5_;
			if (_result_->file != NULL) {
				gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), _result_->file);
			}
			_batch_import_result_unref0 (_result_);
		}
		_g_object_unref0 (_result_list);
	}
	_tmp6_ = gee_collection_get_size (GEE_COLLECTION (manifest->already_imported));
	if (_tmp6_ > 0) {
		GeeArrayList* _tmp7_ = NULL;
		GeeArrayList* to_tombstone;
		_tmp7_ = gee_array_list_new (TYPE_TOMBSTONED_FILE, (GBoxedCopyFunc) tombstoned_file_ref, tombstoned_file_unref, NULL);
		to_tombstone = _tmp7_;
		{
			GeeList* _tmp8_;
			GeeList* _result_list;
			gint _tmp9_;
			gint _result_size;
			gint _result_index;
			_tmp8_ = _g_object_ref0 (manifest->already_imported);
			_result_list = _tmp8_;
			_tmp9_ = gee_collection_get_size (GEE_COLLECTION (_result_list));
			_result_size = _tmp9_;
			_result_index = -1;
			while (TRUE) {
				gpointer _tmp10_ = NULL;
				BatchImportResult* _result_;
				GFileInfo* _tmp11_ = NULL;
				GFileInfo* info;
				gint64 _tmp14_;
				TombstonedFile* _tmp15_ = NULL;
				TombstonedFile* _tmp16_;
				_result_index = _result_index + 1;
				if (!(_result_index < _result_size)) {
					break;
				}
				_tmp10_ = gee_list_get (_result_list, _result_index);
				_result_ = (BatchImportResult*) _tmp10_;
				_tmp11_ = directory_monitor_get_file_info (DIRECTORY_MONITOR (self), _result_->file);
				info = _tmp11_;
				if (info == NULL) {
					gchar* _tmp12_ = NULL;
					gchar* _tmp13_;
					_tmp12_ = g_file_get_path (_result_->file);
					_tmp13_ = _tmp12_;
					g_warning ("LibraryMonitor.vala:691: Unable to get info for duplicate file %s", _tmp13_);
					_g_free0 (_tmp13_);
					_g_object_unref0 (info);
					_batch_import_result_unref0 (_result_);
					continue;
				}
				_tmp14_ = g_file_info_get_size (info);
				_tmp15_ = tombstoned_file_new (_result_->file, _tmp14_, NULL);
				_tmp16_ = _tmp15_;
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_tombstone), _tmp16_);
				_tombstoned_file_unref0 (_tmp16_);
				_g_object_unref0 (info);
				_batch_import_result_unref0 (_result_);
			}
			_g_object_unref0 (_result_list);
		}
		tombstone_entomb_many_files (GEE_COLLECTION (to_tombstone), TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch447_database_error;
			}
			_g_object_unref0 (to_tombstone);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		goto __finally447;
		__catch447_database_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			app_window_database_error (err);
			_g_error_free0 (err);
		}
		__finally447:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (to_tombstone);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_object_unref0 (to_tombstone);
	}
	_tmp17_ = gee_collection_get_size (GEE_COLLECTION (self->priv->pending_imports));
	_tmp18_ = g_strdup_printf ("%d files remain pending for auto-import", _tmp17_);
	_tmp19_ = _tmp18_;
	directory_monitor_mdbg (_tmp19_);
	_g_free0 (_tmp19_);
	library_monitor_discard_current_batch_import (self);
	library_monitor_schedule_next_batch_import (self);
}


void library_monitor_blacklist_file (GFile* file, const gchar* reason) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (reason != NULL);
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("[%s] Blacklisting %s", reason, _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	{
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
		__finally448:
		g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void library_monitor_unblacklist_file (GFile* file) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (G_IS_FILE (file));
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		_tmp1_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
		if (_tmp1_) {
			gboolean _tmp2_;
			_tmp2_ = timed_queue_contains (TIMED_QUEUE (library_monitor_to_unblacklist), file);
			_tmp0_ = !_tmp2_;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			timed_queue_enqueue (TIMED_QUEUE (library_monitor_to_unblacklist), file);
		}
		__finally449:
		g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void library_monitor_on_unblacklist_file (GFile* file) {
	gboolean removed = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (G_IS_FILE (file));
	{
		gboolean _tmp0_;
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		_tmp0_ = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
		removed = _tmp0_;
		__finally450:
		g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (removed) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp1_ = g_file_get_path (file);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup_printf ("Blacklist for %s removed", _tmp2_);
		_tmp4_ = _tmp3_;
		directory_monitor_mdbg (_tmp4_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		_tmp5_ = g_file_get_path (file);
		_tmp6_ = _tmp5_;
		g_warning ("LibraryMonitor.vala:750: File %s was not blacklisted but unblacklisted", _tmp6_);
		_g_free0 (_tmp6_);
	}
}


gboolean library_monitor_is_blacklisted (GFile* file) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	{
		gboolean _tmp0_;
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		_tmp0_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		return result;
		__finally451:
		g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static gboolean library_monitor_is_supported_filetype (LibraryMonitor* self, GFile* file) {
	gboolean result = FALSE;
	MediaCollectionRegistry* _tmp0_ = NULL;
	MediaCollectionRegistry* _tmp1_;
	MediaSourceCollection* _tmp2_ = NULL;
	MediaSourceCollection* _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (IS_LIBRARY_MONITOR (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	_tmp0_ = media_collection_registry_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = media_collection_registry_get_collection_for_file (_tmp1_, file);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ != NULL;
	_data_collection_unref0 (_tmp3_);
	_media_collection_registry_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}


static void library_monitor_import_unrepresented_files (LibraryMonitor* self) {
	GeeArrayList* to_import;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	if (!self->priv->auto_import) {
		return;
	}
	to_import = NULL;
	{
		GeeCollection* _tmp0_ = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _file_it;
		_tmp0_ = directory_monitor_get_files (DIRECTORY_MONITOR (self));
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_file_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			GFile* file;
			GFileInfo* _tmp6_ = NULL;
			GFileInfo* info;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp9_;
			gboolean _tmp10_;
			gboolean represented;
			gboolean _tmp15_;
			_tmp4_ = gee_iterator_next (_file_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp5_;
			_tmp6_ = directory_monitor_get_file_info (DIRECTORY_MONITOR (self), file);
			info = _tmp6_;
			if (info == NULL) {
				_tmp7_ = TRUE;
			} else {
				GFileType _tmp8_;
				_tmp8_ = g_file_info_get_file_type (info);
				_tmp7_ = _tmp8_ != G_FILE_TYPE_REGULAR;
			}
			if (_tmp7_) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			_tmp9_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), file);
			if (_tmp9_) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			_tmp10_ = tombstone_source_collection_matches (tombstone_global, file);
			if (_tmp10_) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			represented = FALSE;
			{
				GeeList* _tmp11_;
				GeeList* _monitor_list;
				gint _tmp12_;
				gint _monitor_size;
				gint _monitor_index;
				_tmp11_ = _g_object_ref0 (self->priv->monitors);
				_monitor_list = _tmp11_;
				_tmp12_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
				_monitor_size = _tmp12_;
				_monitor_index = -1;
				while (TRUE) {
					gpointer _tmp13_ = NULL;
					MediaMonitor* monitor;
					gboolean _tmp14_;
					_monitor_index = _monitor_index + 1;
					if (!(_monitor_index < _monitor_size)) {
						break;
					}
					_tmp13_ = gee_list_get (_monitor_list, _monitor_index);
					monitor = (MediaMonitor*) _tmp13_;
					_tmp14_ = media_monitor_is_file_represented (monitor, file);
					if (_tmp14_) {
						represented = TRUE;
						_g_object_unref0 (monitor);
						break;
					}
					_g_object_unref0 (monitor);
				}
				_g_object_unref0 (_monitor_list);
			}
			if (represented) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			_tmp15_ = library_monitor_is_supported_filetype (self, file);
			if (!_tmp15_) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			if (to_import == NULL) {
				GeeArrayList* _tmp16_ = NULL;
				_tmp16_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
				_g_object_unref0 (to_import);
				to_import = _tmp16_;
			}
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_import), file);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
	if (to_import != NULL) {
		library_monitor_enqueue_import_many (self, GEE_COLLECTION (to_import));
	}
	_g_object_unref0 (to_import);
}


static void library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self, GFile* file) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	if (self->priv->auto_import) {
		gboolean _tmp2_;
		_tmp2_ = library_monitor_is_supported_filetype (self, file);
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp3_;
		_tmp3_ = tombstone_source_collection_matches (tombstone_global, file);
		_tmp0_ = !_tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		_tmp4_ = g_file_get_path (file);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("Unknown file %s discovered, enqueuing for import", _tmp5_);
		_tmp7_ = _tmp6_;
		directory_monitor_mdbg (_tmp7_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		library_monitor_enqueue_import (self, file);
	}
}


static void library_monitor_real_notify_file_created (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
	LibraryMonitor * self;
	gboolean _tmp0_;
	gboolean known;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = library_monitor_is_blacklisted (file);
	if (_tmp0_) {
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (DIRECTORY_MONITOR (self), file, info);
		return;
	}
	known = FALSE;
	{
		GeeList* _tmp1_;
		GeeList* _monitor_list;
		gint _tmp2_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp1_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp2_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp3_ = NULL;
			MediaMonitor* monitor;
			gboolean _tmp4_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp3_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp3_;
			_tmp4_ = media_monitor_notify_file_created (monitor, file, info);
			if (_tmp4_) {
				known = TRUE;
				_g_object_unref0 (monitor);
				break;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (!known) {
		GeeHashSet* all_candidates;
		gboolean _tmp32_ = FALSE;
		gboolean _tmp33_ = FALSE;
		all_candidates = NULL;
		{
			GeeList* _tmp5_;
			GeeList* _monitor_list;
			gint _tmp6_;
			gint _monitor_size;
			gint _monitor_index;
			_tmp5_ = _g_object_ref0 (self->priv->monitors);
			_monitor_list = _tmp5_;
			_tmp6_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
			_monitor_size = _tmp6_;
			_monitor_index = -1;
			while (TRUE) {
				gpointer _tmp7_ = NULL;
				MediaMonitor* monitor;
				MediaMonitorDiscoveredFile _result_ = 0;
				MediaMonitorDiscoveredFile _tmp8_;
				GeeCollection* _tmp9_ = NULL;
				GeeCollection* candidates;
				gboolean _tmp10_ = FALSE;
				_monitor_index = _monitor_index + 1;
				if (!(_monitor_index < _monitor_size)) {
					break;
				}
				_tmp7_ = gee_list_get (_monitor_list, _monitor_index);
				monitor = (MediaMonitor*) _tmp7_;
				_tmp9_ = media_monitor_candidates_for_unknown_file (monitor, file, info, &_tmp8_);
				_result_ = _tmp8_;
				candidates = _tmp9_;
				if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
					_tmp10_ = TRUE;
				} else {
					_tmp10_ = _result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
				}
				if (_tmp10_) {
					gchar* _tmp11_ = NULL;
					gchar* _tmp12_;
					GEnumValue* _tmp13_;
					gchar* _tmp14_ = NULL;
					gchar* _tmp15_;
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_;
					_tmp11_ = media_monitor_to_string (monitor);
					_tmp12_ = _tmp11_;
					_tmp13_ = g_enum_get_value (g_type_class_ref (MEDIA_MONITOR_TYPE_DISCOVERED_FILE), _result_);
					_tmp14_ = g_file_get_path (file);
					_tmp15_ = _tmp14_;
					_tmp16_ = g_strdup_printf ("%s %s created file %s", _tmp12_, (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, _tmp15_);
					_tmp17_ = _tmp16_;
					directory_monitor_mdbg (_tmp17_);
					_g_free0 (_tmp17_);
					_g_free0 (_tmp15_);
					_g_free0 (_tmp12_);
					known = TRUE;
					_g_object_unref0 (candidates);
					_g_object_unref0 (monitor);
					break;
				} else {
					gboolean _tmp18_ = FALSE;
					if (candidates != NULL) {
						gint _tmp19_;
						_tmp19_ = gee_collection_get_size (candidates);
						_tmp18_ = _tmp19_ > 0;
					} else {
						_tmp18_ = FALSE;
					}
					if (_tmp18_) {
						gchar* _tmp20_ = NULL;
						gchar* _tmp21_;
						gint _tmp22_;
						gchar* _tmp23_ = NULL;
						gchar* _tmp24_;
						gchar* _tmp25_ = NULL;
						gchar* _tmp26_;
						_tmp20_ = media_monitor_to_string (monitor);
						_tmp21_ = _tmp20_;
						_tmp22_ = gee_collection_get_size (candidates);
						_tmp23_ = g_file_get_path (file);
						_tmp24_ = _tmp23_;
						_tmp25_ = g_strdup_printf ("%s suggests %d candidates for created file %s", _tmp21_, _tmp22_, _tmp24_);
						_tmp26_ = _tmp25_;
						directory_monitor_mdbg (_tmp26_);
						_g_free0 (_tmp26_);
						_g_free0 (_tmp24_);
						_g_free0 (_tmp21_);
						if (all_candidates == NULL) {
							GeeHashSet* _tmp27_ = NULL;
							_tmp27_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
							_g_object_unref0 (all_candidates);
							all_candidates = _tmp27_;
						}
						{
							GeeIterator* _tmp28_ = NULL;
							GeeIterator* _candidate_it;
							_tmp28_ = gee_iterable_iterator (GEE_ITERABLE (candidates));
							_candidate_it = _tmp28_;
							while (TRUE) {
								gboolean _tmp29_;
								gpointer _tmp30_ = NULL;
								Monitorable* candidate;
								gboolean _tmp31_;
								_tmp29_ = gee_iterator_next (_candidate_it);
								if (!_tmp29_) {
									break;
								}
								_tmp30_ = gee_iterator_get (_candidate_it);
								candidate = (Monitorable*) _tmp30_;
								_tmp31_ = media_monitor_is_offline (monitor, candidate);
								if (_tmp31_) {
									gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (all_candidates), candidate);
								}
								_g_object_unref0 (candidate);
							}
							_g_object_unref0 (_candidate_it);
						}
					}
				}
				_g_object_unref0 (candidates);
				_g_object_unref0 (monitor);
			}
			_g_object_unref0 (_monitor_list);
		}
		if (!known) {
			_tmp33_ = all_candidates != NULL;
		} else {
			_tmp33_ = FALSE;
		}
		if (_tmp33_) {
			gint _tmp34_;
			_tmp34_ = gee_collection_get_size (GEE_COLLECTION (all_candidates));
			_tmp32_ = _tmp34_ > 0;
		} else {
			_tmp32_ = FALSE;
		}
		if (_tmp32_) {
			gint _tmp35_;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_;
			LibraryMonitorRuntimeFindMoveJob* _tmp40_ = NULL;
			LibraryMonitorRuntimeFindMoveJob* _tmp41_;
			_tmp35_ = gee_collection_get_size (GEE_COLLECTION (all_candidates));
			_tmp36_ = g_file_get_path (file);
			_tmp37_ = _tmp36_;
			_tmp38_ = g_strdup_printf ("%d candidates for created file %s being checksummed", _tmp35_, _tmp37_);
			_tmp39_ = _tmp38_;
			directory_monitor_mdbg (_tmp39_);
			_g_free0 (_tmp39_);
			_g_free0 (_tmp37_);
			_tmp40_ = library_monitor_runtime_find_move_job_new (self, file, GEE_COLLECTION (all_candidates));
			_tmp41_ = _tmp40_;
			workers_enqueue (self->priv->workers, BACKGROUND_JOB (_tmp41_));
			_background_job_unref0 (_tmp41_);
			known = TRUE;
		}
		_g_object_unref0 (all_candidates);
	}
	if (!known) {
		library_monitor_runtime_unknown_file_discovered (self, file);
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (DIRECTORY_MONITOR (self), file, info);
}


static void library_monitor_on_runtime_find_move_completed (LibraryMonitor* self, BackgroundJob* j) {
	LibraryMonitorRuntimeFindMoveJob* _tmp0_;
	LibraryMonitorRuntimeFindMoveJob* job;
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
	g_return_if_fail (IS_BACKGROUND_JOB (j));
	_tmp0_ = _background_job_ref0 (LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB (j));
	job = _tmp0_;
	if (job->err != NULL) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		_tmp1_ = g_file_get_path (job->file);
		_tmp2_ = _tmp1_;
		g_critical ("LibraryMonitor.vala:880: Error attempting to find a match at runtime f" \
"or %s: %s", _tmp2_, job->err->message);
		_g_free0 (_tmp2_);
	}
	if (job->match != NULL) {
		MediaMonitor* _tmp3_ = NULL;
		MediaMonitor* monitor;
		_tmp3_ = library_monitor_get_monitor_for_monitorable (self, job->match);
		monitor = _tmp3_;
		media_monitor_update_master_file (monitor, job->match, job->file);
		media_monitor_update_online (monitor, job->match);
		_g_object_unref0 (monitor);
	} else {
		library_monitor_runtime_unknown_file_discovered (self, job->file);
	}
	_background_job_unref0 (job);
}


static void library_monitor_real_notify_file_moved (DirectoryMonitor* base, GFile* old_file, GFile* new_file, GFileInfo* new_info) {
	LibraryMonitor * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean known;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (old_file));
	g_return_if_fail (G_IS_FILE (new_file));
	g_return_if_fail (G_IS_FILE_INFO (new_info));
	_tmp1_ = library_monitor_is_blacklisted (old_file);
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = library_monitor_is_blacklisted (new_file);
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (DIRECTORY_MONITOR (self), old_file, new_file, new_info);
		return;
	}
	known = FALSE;
	{
		GeeList* _tmp3_;
		GeeList* _monitor_list;
		gint _tmp4_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp3_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp3_;
		_tmp4_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp4_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp5_ = NULL;
			MediaMonitor* monitor;
			gboolean _tmp6_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp5_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp5_;
			_tmp6_ = media_monitor_notify_file_moved (monitor, old_file, new_file, new_info);
			if (_tmp6_) {
				known = TRUE;
				_g_object_unref0 (monitor);
				break;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (!known) {
		library_monitor_runtime_unknown_file_discovered (self, new_file);
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (DIRECTORY_MONITOR (self), old_file, new_file, new_info);
}


static void library_monitor_real_notify_file_altered (DirectoryMonitor* base, GFile* file) {
	LibraryMonitor * self;
	gboolean _tmp0_;
	gboolean known;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = library_monitor_is_blacklisted (file);
	if (_tmp0_) {
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (DIRECTORY_MONITOR (self), file);
		return;
	}
	known = FALSE;
	{
		GeeList* _tmp1_;
		GeeList* _monitor_list;
		gint _tmp2_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp1_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp2_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp3_ = NULL;
			MediaMonitor* monitor;
			gboolean _tmp4_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp3_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp3_;
			_tmp4_ = media_monitor_notify_file_altered (monitor, file);
			if (_tmp4_) {
				known = TRUE;
				_g_object_unref0 (monitor);
				break;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (!known) {
		library_monitor_runtime_unknown_file_discovered (self, file);
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (DIRECTORY_MONITOR (self), file);
}


static void library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base, GFile* file) {
	LibraryMonitor * self;
	gboolean _tmp0_;
	gboolean known;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = library_monitor_is_blacklisted (file);
	if (_tmp0_) {
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (DIRECTORY_MONITOR (self), file);
		return;
	}
	known = FALSE;
	{
		GeeList* _tmp1_;
		GeeList* _monitor_list;
		gint _tmp2_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp1_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp2_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp3_ = NULL;
			MediaMonitor* monitor;
			gboolean _tmp4_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp3_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp3_;
			_tmp4_ = media_monitor_notify_file_attributes_altered (monitor, file);
			if (_tmp4_) {
				known = TRUE;
				_g_object_unref0 (monitor);
				break;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (!known) {
		library_monitor_runtime_unknown_file_discovered (self, file);
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (DIRECTORY_MONITOR (self), file);
}


static void library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
	LibraryMonitor * self;
	gboolean _tmp0_;
	gboolean known;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = library_monitor_is_blacklisted (file);
	if (_tmp0_) {
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (DIRECTORY_MONITOR (self), file, info);
		return;
	}
	known = FALSE;
	{
		GeeList* _tmp1_;
		GeeList* _monitor_list;
		gint _tmp2_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp1_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp2_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp3_ = NULL;
			MediaMonitor* monitor;
			gboolean _tmp4_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp3_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp3_;
			_tmp4_ = media_monitor_notify_file_alteration_completed (monitor, file, info);
			if (_tmp4_) {
				known = TRUE;
				_g_object_unref0 (monitor);
				break;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (!known) {
		library_monitor_runtime_unknown_file_discovered (self, file);
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (DIRECTORY_MONITOR (self), file, info);
}


static void library_monitor_real_notify_file_deleted (DirectoryMonitor* base, GFile* file) {
	LibraryMonitor * self;
	gboolean _tmp0_;
	gboolean known;
	self = LIBRARY_MONITOR (base);
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = library_monitor_is_blacklisted (file);
	if (_tmp0_) {
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (DIRECTORY_MONITOR (self), file);
		return;
	}
	known = FALSE;
	{
		GeeList* _tmp1_;
		GeeList* _monitor_list;
		gint _tmp2_;
		gint _monitor_size;
		gint _monitor_index;
		_tmp1_ = _g_object_ref0 (self->priv->monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_monitor_list));
		_monitor_size = _tmp2_;
		_monitor_index = -1;
		while (TRUE) {
			gpointer _tmp3_ = NULL;
			MediaMonitor* monitor;
			gboolean _tmp4_;
			_monitor_index = _monitor_index + 1;
			if (!(_monitor_index < _monitor_size)) {
				break;
			}
			_tmp3_ = gee_list_get (_monitor_list, _monitor_index);
			monitor = (MediaMonitor*) _tmp3_;
			_tmp4_ = media_monitor_notify_file_deleted (monitor, file);
			if (_tmp4_) {
				known = TRUE;
				_g_object_unref0 (monitor);
				break;
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	if (!known) {
		Tombstone* _tmp5_ = NULL;
		Tombstone* tombstone;
		_tmp5_ = tombstone_source_collection_locate (tombstone_global, file);
		tombstone = _tmp5_;
		if (tombstone != NULL) {
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			_tmp6_ = g_file_get_path (file);
			_tmp7_ = _tmp6_;
			g_debug ("LibraryMonitor.vala:1002: Resurrecting tombstoned file %s", _tmp7_);
			_g_free0 (_tmp7_);
			tombstone_source_collection_resurrect (tombstone_global, tombstone);
		}
		library_monitor_remove_queued_import (self, file);
		_g_object_unref0 (tombstone);
	}
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (DIRECTORY_MONITOR (self), file);
}


static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT64_UINT64) (gpointer data1, guint64 arg_1, guint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT64_UINT64 callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT64_UINT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint64 (param_values + 1), g_value_get_uint64 (param_values + 2), data2);
}


static void _library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job, gpointer self) {
	library_monitor_on_find_move_completed (self, job);
}


static void _library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
	library_monitor_on_find_move_cancelled (self, job);
}


static LibraryMonitorFindMoveJob* library_monitor_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
	LibraryMonitorFindMoveJob* self = NULL;
	GFile* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_val_if_fail (IS_LIBRARY_MONITOR (owner), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	g_return_val_if_fail (GEE_IS_COLLECTION (candidates), NULL);
	self = (LibraryMonitorFindMoveJob*) background_job_construct (object_type, G_OBJECT (owner), _library_monitor_on_find_move_completed_completion_callback, owner, owner->priv->cancellable, _library_monitor_on_find_move_cancelled_cancellation_callback, owner, NULL);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->file);
	self->file = _tmp0_;
	_tmp1_ = _g_object_ref0 (candidates);
	_g_object_unref0 (self->candidates);
	self->candidates = _tmp1_;
	background_job_set_completion_priority (BACKGROUND_JOB (self), G_PRIORITY_LOW);
	return self;
}


static LibraryMonitorFindMoveJob* library_monitor_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
	return library_monitor_find_move_job_construct (LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, owner, file, candidates);
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static void library_monitor_find_move_job_real_execute (BackgroundJob* base) {
	LibraryMonitorFindMoveJob * self;
	GeeIterator* _tmp0_ = NULL;
	GeeIterator* iter;
	gint _tmp8_;
	gchar* md5;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
	self = LIBRARY_MONITOR_FIND_MOVE_JOB (base);
	_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (self->candidates));
	iter = _tmp0_;
	while (TRUE) {
		gboolean _tmp1_;
		gpointer _tmp2_ = NULL;
		Monitorable* _tmp3_;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp1_ = gee_iterator_next (iter);
		if (!_tmp1_) {
			break;
		}
		_tmp2_ = gee_iterator_get (iter);
		_tmp3_ = (Monitorable*) _tmp2_;
		_tmp4_ = media_source_get_master_file (MEDIA_SOURCE (_tmp3_));
		_tmp5_ = _tmp4_;
		_tmp6_ = g_file_query_exists (_tmp5_, NULL);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
		if (_tmp7_) {
			gee_iterator_remove (iter);
		}
	}
	_tmp8_ = gee_collection_get_size (self->candidates);
	if (_tmp8_ == 0) {
		_g_object_unref0 (iter);
		return;
	}
	md5 = NULL;
	_tmp9_ = md5_file (self->file, &_inner_error_);
	_tmp10_ = _tmp9_;
	if (_inner_error_ != NULL) {
		goto __catch452_g_error;
	}
	_g_free0 (md5);
	md5 = _tmp10_;
	goto __finally452;
	__catch452_g_error:
	{
		GError * err;
		GError* _tmp11_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = _g_error_copy0 (err);
		_g_error_free0 (self->err);
		self->err = _tmp11_;
		_g_error_free0 (err);
		_g_free0 (md5);
		_g_object_unref0 (iter);
		return;
	}
	__finally452:
	if (_inner_error_ != NULL) {
		_g_free0 (md5);
		_g_object_unref0 (iter);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GeeIterator* _tmp12_ = NULL;
		GeeIterator* _candidate_it;
		_tmp12_ = gee_iterable_iterator (GEE_ITERABLE (self->candidates));
		_candidate_it = _tmp12_;
		while (TRUE) {
			gboolean _tmp13_;
			gpointer _tmp14_ = NULL;
			Monitorable* candidate;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_;
			gboolean _tmp17_;
			Monitorable* _tmp25_;
			_tmp13_ = gee_iterator_next (_candidate_it);
			if (!_tmp13_) {
				break;
			}
			_tmp14_ = gee_iterator_get (_candidate_it);
			candidate = (Monitorable*) _tmp14_;
			_tmp15_ = media_source_get_master_md5 (MEDIA_SOURCE (candidate));
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strcmp0 (_tmp16_, md5) != 0;
			_g_free0 (_tmp16_);
			if (_tmp17_) {
				_g_object_unref0 (candidate);
				continue;
			}
			if (self->match != NULL) {
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_;
				gchar* _tmp20_ = NULL;
				gchar* _tmp21_;
				gchar* _tmp22_ = NULL;
				gchar* _tmp23_;
				_tmp18_ = g_file_get_path (self->file);
				_tmp19_ = _tmp18_;
				_tmp20_ = data_object_to_string (DATA_OBJECT (self->match));
				_tmp21_ = _tmp20_;
				_tmp22_ = data_object_to_string (DATA_OBJECT (candidate));
				_tmp23_ = _tmp22_;
				g_warning ("LibraryMonitor.vala:145: Found more than one media match for %s: %s an" \
"d %s", _tmp19_, _tmp21_, _tmp23_);
				_g_free0 (_tmp23_);
				_g_free0 (_tmp21_);
				_g_free0 (_tmp19_);
				if (self->losers == NULL) {
					GeeArrayList* _tmp24_ = NULL;
					_tmp24_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
					_g_object_unref0 (self->losers);
					self->losers = _tmp24_;
				}
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->losers), candidate);
				_g_object_unref0 (candidate);
				continue;
			}
			_tmp25_ = _g_object_ref0 (candidate);
			_g_object_unref0 (self->match);
			self->match = _tmp25_;
			_g_object_unref0 (candidate);
		}
		_g_object_unref0 (_candidate_it);
	}
	_g_free0 (md5);
	_g_object_unref0 (iter);
}


static void library_monitor_find_move_job_class_init (LibraryMonitorFindMoveJobClass * klass) {
	library_monitor_find_move_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = library_monitor_find_move_job_finalize;
	BACKGROUND_JOB_CLASS (klass)->execute = library_monitor_find_move_job_real_execute;
}


static void library_monitor_find_move_job_instance_init (LibraryMonitorFindMoveJob * self) {
	self->match = NULL;
	self->losers = NULL;
	self->err = NULL;
}


static void library_monitor_find_move_job_finalize (BackgroundJob* obj) {
	LibraryMonitorFindMoveJob * self;
	self = LIBRARY_MONITOR_FIND_MOVE_JOB (obj);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->candidates);
	_g_object_unref0 (self->match);
	_g_object_unref0 (self->losers);
	_g_error_free0 (self->err);
	BACKGROUND_JOB_CLASS (library_monitor_find_move_job_parent_class)->finalize (obj);
}


static GType library_monitor_find_move_job_get_type (void) {
	static volatile gsize library_monitor_find_move_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_find_move_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorFindMoveJob), 0, (GInstanceInitFunc) library_monitor_find_move_job_instance_init, NULL };
		GType library_monitor_find_move_job_type_id;
		library_monitor_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorFindMoveJob", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_find_move_job_type_id__volatile, library_monitor_find_move_job_type_id);
	}
	return library_monitor_find_move_job_type_id__volatile;
}


static void _library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job, gpointer self) {
	library_monitor_on_runtime_find_move_completed (self, job);
}


static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
	LibraryMonitorRuntimeFindMoveJob* self = NULL;
	GFile* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_val_if_fail (IS_LIBRARY_MONITOR (owner), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	g_return_val_if_fail (GEE_IS_COLLECTION (candidates), NULL);
	self = (LibraryMonitorRuntimeFindMoveJob*) background_job_construct (object_type, G_OBJECT (owner), _library_monitor_on_runtime_find_move_completed_completion_callback, owner, owner->priv->cancellable, NULL, NULL, NULL);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->file);
	self->file = _tmp0_;
	_tmp1_ = _g_object_ref0 (candidates);
	_g_object_unref0 (self->candidates);
	self->candidates = _tmp1_;
	background_job_set_completion_priority (BACKGROUND_JOB (self), G_PRIORITY_LOW);
	return self;
}


static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
	return library_monitor_runtime_find_move_job_construct (LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, owner, file, candidates);
}


static void library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base) {
	LibraryMonitorRuntimeFindMoveJob * self;
	gchar* md5;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	self = LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB (base);
	md5 = NULL;
	_tmp0_ = md5_file (self->file, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		goto __catch453_g_error;
	}
	_g_free0 (md5);
	md5 = _tmp1_;
	goto __finally453;
	__catch453_g_error:
	{
		GError * err;
		GError* _tmp2_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = _g_error_copy0 (err);
		_g_error_free0 (self->err);
		self->err = _tmp2_;
		_g_error_free0 (err);
		_g_free0 (md5);
		return;
	}
	__finally453:
	if (_inner_error_ != NULL) {
		_g_free0 (md5);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _candidate_it;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (self->candidates));
		_candidate_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			Monitorable* candidate;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			gboolean _tmp8_;
			_tmp4_ = gee_iterator_next (_candidate_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_candidate_it);
			candidate = (Monitorable*) _tmp5_;
			_tmp6_ = media_source_get_master_md5 (MEDIA_SOURCE (candidate));
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strcmp0 (_tmp7_, md5) == 0;
			_g_free0 (_tmp7_);
			if (_tmp8_) {
				Monitorable* _tmp9_;
				_tmp9_ = _g_object_ref0 (candidate);
				_g_object_unref0 (self->match);
				self->match = _tmp9_;
				_g_object_unref0 (candidate);
				break;
			}
			_g_object_unref0 (candidate);
		}
		_g_object_unref0 (_candidate_it);
	}
	_g_free0 (md5);
}


static void library_monitor_runtime_find_move_job_class_init (LibraryMonitorRuntimeFindMoveJobClass * klass) {
	library_monitor_runtime_find_move_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = library_monitor_runtime_find_move_job_finalize;
	BACKGROUND_JOB_CLASS (klass)->execute = library_monitor_runtime_find_move_job_real_execute;
}


static void library_monitor_runtime_find_move_job_instance_init (LibraryMonitorRuntimeFindMoveJob * self) {
	self->match = NULL;
	self->err = NULL;
}


static void library_monitor_runtime_find_move_job_finalize (BackgroundJob* obj) {
	LibraryMonitorRuntimeFindMoveJob * self;
	self = LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB (obj);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->candidates);
	_g_object_unref0 (self->match);
	_g_error_free0 (self->err);
	BACKGROUND_JOB_CLASS (library_monitor_runtime_find_move_job_parent_class)->finalize (obj);
}


static GType library_monitor_runtime_find_move_job_get_type (void) {
	static volatile gsize library_monitor_runtime_find_move_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_runtime_find_move_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorRuntimeFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_runtime_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorRuntimeFindMoveJob), 0, (GInstanceInitFunc) library_monitor_runtime_find_move_job_instance_init, NULL };
		GType library_monitor_runtime_find_move_job_type_id;
		library_monitor_runtime_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorRuntimeFindMoveJob", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_runtime_find_move_job_type_id__volatile, library_monitor_runtime_find_move_job_type_id);
	}
	return library_monitor_runtime_find_move_job_type_id__volatile;
}


static LibraryMonitorVerifyJob* library_monitor_verify_job_construct (GType object_type, Monitorable* monitorable, MediaMonitor* monitor) {
	LibraryMonitorVerifyJob* self = NULL;
	Monitorable* _tmp0_;
	MediaMonitor* _tmp1_;
	g_return_val_if_fail (IS_MONITORABLE (monitorable), NULL);
	g_return_val_if_fail (IS_MEDIA_MONITOR (monitor), NULL);
	self = (LibraryMonitorVerifyJob*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (monitorable);
	_g_object_unref0 (self->monitorable);
	self->monitorable = _tmp0_;
	_tmp1_ = _g_object_ref0 (monitor);
	_g_object_unref0 (self->monitor);
	self->monitor = _tmp1_;
	return self;
}


static LibraryMonitorVerifyJob* library_monitor_verify_job_new (Monitorable* monitorable, MediaMonitor* monitor) {
	return library_monitor_verify_job_construct (LIBRARY_MONITOR_TYPE_VERIFY_JOB, monitorable, monitor);
}


static void library_monitor_value_verify_job_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void library_monitor_value_verify_job_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		library_monitor_verify_job_unref (value->data[0].v_pointer);
	}
}


static void library_monitor_value_verify_job_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = library_monitor_verify_job_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer library_monitor_value_verify_job_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* library_monitor_value_verify_job_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		LibraryMonitorVerifyJob* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = library_monitor_verify_job_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* library_monitor_value_verify_job_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	LibraryMonitorVerifyJob** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = library_monitor_verify_job_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* library_monitor_param_spec_verify_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	LibraryMonitorParamSpecVerifyJob* spec;
	g_return_val_if_fail (g_type_is_a (object_type, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer library_monitor_value_get_verify_job (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
	return value->data[0].v_pointer;
}


static void library_monitor_value_set_verify_job (GValue* value, gpointer v_object) {
	LibraryMonitorVerifyJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		library_monitor_verify_job_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_verify_job_unref (old);
	}
}


static void library_monitor_value_take_verify_job (GValue* value, gpointer v_object) {
	LibraryMonitorVerifyJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_verify_job_unref (old);
	}
}


static void library_monitor_verify_job_class_init (LibraryMonitorVerifyJobClass * klass) {
	library_monitor_verify_job_parent_class = g_type_class_peek_parent (klass);
	LIBRARY_MONITOR_VERIFY_JOB_CLASS (klass)->finalize = library_monitor_verify_job_finalize;
}


static void library_monitor_verify_job_instance_init (LibraryMonitorVerifyJob * self) {
	self->ref_count = 1;
}


static void library_monitor_verify_job_finalize (LibraryMonitorVerifyJob* obj) {
	LibraryMonitorVerifyJob * self;
	self = LIBRARY_MONITOR_VERIFY_JOB (obj);
	_g_object_unref0 (self->monitorable);
	_g_object_unref0 (self->monitor);
}


static GType library_monitor_verify_job_get_type (void) {
	static volatile gsize library_monitor_verify_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_verify_job_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { library_monitor_value_verify_job_init, library_monitor_value_verify_job_free_value, library_monitor_value_verify_job_copy_value, library_monitor_value_verify_job_peek_pointer, "p", library_monitor_value_verify_job_collect_value, "p", library_monitor_value_verify_job_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorVerifyJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_verify_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorVerifyJob), 0, (GInstanceInitFunc) library_monitor_verify_job_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType library_monitor_verify_job_type_id;
		library_monitor_verify_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorVerifyJob", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&library_monitor_verify_job_type_id__volatile, library_monitor_verify_job_type_id);
	}
	return library_monitor_verify_job_type_id__volatile;
}


static gpointer library_monitor_verify_job_ref (gpointer instance) {
	LibraryMonitorVerifyJob* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void library_monitor_verify_job_unref (gpointer instance) {
	LibraryMonitorVerifyJob* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void library_monitor_class_init (LibraryMonitorClass * klass) {
	GeeHashSet* _tmp0_ = NULL;
	HashTimedQueue* _tmp1_ = NULL;
	library_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LibraryMonitorPrivate));
	DIRECTORY_MONITOR_CLASS (klass)->close = library_monitor_real_close;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = library_monitor_real_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = library_monitor_real_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = library_monitor_real_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = library_monitor_real_notify_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = library_monitor_real_notify_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = library_monitor_real_notify_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = library_monitor_real_notify_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = library_monitor_real_notify_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = library_monitor_real_notify_file_deleted;
	G_OBJECT_CLASS (klass)->finalize = library_monitor_finalize;
	g_signal_new ("auto_update_progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
	g_signal_new ("auto_import_preparing", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("auto_import_progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT64_UINT64, G_TYPE_NONE, 2, G_TYPE_UINT64, G_TYPE_UINT64);
	g_static_rec_mutex_init (&__lock_library_monitor_blacklist);
	_tmp0_ = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	library_monitor_blacklist = _tmp0_;
	_tmp1_ = hash_timed_queue_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, (guint) LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC, _library_monitor_on_unblacklist_file_dequeued_callback, NULL, g_file_hash, g_file_equal, G_PRIORITY_LOW);
	library_monitor_to_unblacklist = _tmp1_;
}


static void library_monitor_instance_init (LibraryMonitor * self) {
	gint _tmp0_;
	Workers* _tmp1_ = NULL;
	GCancellable* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeHashSet* _tmp4_ = NULL;
	GeeHashSet* _tmp5_ = NULL;
	GeeArrayList* _tmp6_ = NULL;
	GeeLinkedList* _tmp7_ = NULL;
	self->priv = LIBRARY_MONITOR_GET_PRIVATE (self);
	_tmp0_ = workers_thread_per_cpu_minus_one ();
	_tmp1_ = workers_new (_tmp0_, FALSE);
	self->priv->workers = _tmp1_;
	_tmp2_ = g_cancellable_new ();
	self->priv->cancellable = _tmp2_;
	self->priv->auto_import = FALSE;
	self->priv->unknown_files = NULL;
	_tmp3_ = gee_array_list_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->priv->monitors = GEE_LIST (_tmp3_);
	self->priv->discovered = NULL;
	_tmp4_ = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	self->priv->import_queue = _tmp4_;
	_tmp5_ = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	self->priv->pending_imports = _tmp5_;
	_tmp6_ = gee_array_list_new (TYPE_BATCH_IMPORT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->priv->batch_import_queue = _tmp6_;
	self->priv->current_import_roll = NULL;
	self->priv->last_import_roll_use = (time_t) 0;
	self->priv->current_batch_import = NULL;
	self->priv->checksums_completed = 0;
	self->priv->checksums_total = 0;
	self->priv->import_queue_timer_id = (guint) 0;
	_tmp7_ = gee_linked_list_new (LIBRARY_MONITOR_TYPE_VERIFY_JOB, (GBoxedCopyFunc) library_monitor_verify_job_ref, library_monitor_verify_job_unref, NULL);
	self->priv->verify_queue = GEE_QUEUE (_tmp7_);
	self->priv->outstanding_verify_jobs = 0;
	self->priv->completed_monitorable_verifies = 0;
	self->priv->total_monitorable_verifies = 0;
}


static void library_monitor_finalize (GObject* obj) {
	LibraryMonitor * self;
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_;
	guint _tmp2_;
	self = LIBRARY_MONITOR (obj);
	_tmp0_ = config_facade_get_instance ();
	_tmp1_ = _tmp0_;
	g_signal_parse_name ("auto-import-from-library-changed", TYPE_CONFIGURATION_FACADE, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (CONFIGURATION_FACADE (_tmp1_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _library_monitor_on_config_changed_configuration_facade_auto_import_from_library_changed, self);
	_g_object_unref0 (_tmp1_);
	_workers_unref0 (self->priv->workers);
	_g_object_unref0 (self->priv->cancellable);
	_g_object_unref0 (self->priv->unknown_files);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->discovered);
	_g_object_unref0 (self->priv->import_queue);
	_g_object_unref0 (self->priv->pending_imports);
	_g_object_unref0 (self->priv->batch_import_queue);
	_batch_import_roll_unref0 (self->priv->current_import_roll);
	_g_object_unref0 (self->priv->current_batch_import);
	_g_object_unref0 (self->priv->verify_queue);
	G_OBJECT_CLASS (library_monitor_parent_class)->finalize (obj);
}


GType library_monitor_get_type (void) {
	static volatile gsize library_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitor), 0, (GInstanceInitFunc) library_monitor_instance_init, NULL };
		GType library_monitor_type_id;
		library_monitor_type_id = g_type_register_static (TYPE_DIRECTORY_MONITOR, "LibraryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_type_id__volatile, library_monitor_type_id);
	}
	return library_monitor_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



